//TSO2NETV JOB ,FORGHETT.RALVMM,MSGLEVEL=(1,1),CLASS=A                  00000100
//        EXEC ASMHCL,PARM.ASM='OBJECT,DECK,XREF(SHORT)',               00000200
//             PARM.LKED='LIST,XREF,MAP,AMODE=24,RMODE=24',             00000300
//             COND.PRINT=                                              00000400
//ASM.SYSIN     DD *                                                    00000500
TSO2NETV CSECT                                                          00000600
R0       EQU   0                                                        00000700
R1       EQU   1                                                        00000800
R2       EQU   2                                                        00000900
R3       EQU   3                                                        00001000
R4       EQU   4                                                        00001100
R5       EQU   5                                                        00001200
R6       EQU   6                                                        00001300
R7       EQU   7                                                        00001400
R8       EQU   8                                                        00001500
R9       EQU   9                                                        00001600
R10      EQU   10                                                       00001700
R11      EQU   11                                                       00001800
R12      EQU   12                                                       00001900
R13      EQU   13                                                       00002000
R14      EQU   14                                                       00002100
R15      EQU   15                                                       00002200
         EJECT                                                          00002300
*********************************************************************** 00002400
*********************************************************************** 00002500
***                                                                 *** 00002600
***  (C)  Copyright  IBM  Corp.  1994                               *** 00002700
***  No warranty expressed or implied.                              *** 00002800
***                                                                 *** 00002900
***                                                                 *** 00003000
***                      T S O 2 N E T V                            *** 00003100
***                                                                 *** 00003200
***     This is a TSO command processor that uses LU 6.2 to send    *** 00003300
***  a command to NetView to be executed, receives the response     *** 00003400
***  and displays it.                                               *** 00003500
***                                                                 *** 00003600
***                                                                 *** 00003700
***  Installation:  Assemble and linkedit code as reusable 'REUS'.  *** 00003800
***                 Linkedit the command into a linklst library.    *** 00003900
***                 Linkage editor parms 'REUS,AMODE=24,RMODE=24'   *** 00004000
***                                                                 *** 00004100
***  Operation syntax:  TSO2NETV domain-id command-text             *** 00004200
***                                                                 *** 00004300
***     Where domain-id is the NetView domain id.                   *** 00004400
***                                                                 *** 00004500
***     Where command-text is the command and parameters to be      *** 00004600
***     executed.                                                   *** 00004700
***                                                                 *** 00004800
***  Gary Forghetti                                                 *** 00004900
***  IBM Corporation                                                *** 00005000
***  Network Mgmt Products Field Support                            *** 00005100
***  Research Triangle Park, North Carolina                         *** 00005200
***                                                                 *** 00005300
***  February 3rd,1994                                              *** 00005400
***                                                                 *** 00005500
*********************************************************************** 00005600
*********************************************************************** 00005700
         EJECT                                                          00005800
         USING *,R15                                                    00005900
         B     PROLOG                                                   00006000
         DC    C'TSO2NETV &SYSDATE. AT &SYSTIME. '                      00006100
         DC    C'COPYRIGHT IBM CORPORATION 1994, '                      00006200
         DC    C'NO WARRANTY EXPRESSED OR IMPLIED.'                     00006300
PROLOG   DS    0H                                                       00006400
         STM   R14,R12,12(R13)  SAVE CALLING PGMS REGISTERS             00006500
*                                                                       00006600
         LR    R10,R15          GET ENTRY POINT ADDRESS FOR BASE REG    00006700
         LA    R11,4095(R10)    GET 2ND BASE REGISTER                   00006800
         LA    R11,1(R11)                                               00006900
         LA    R12,4095(R11)    GET 3RD BASE REGISTER                   00007000
         LA    R12,1(R12)                                               00007100
         DROP  R15                                                      00007200
*                                                                       00007300
         USING TSO2NETV,R10,R11,R12 SET UP BASE REGISTERS               00007400
*                                                                       00007500
         ST    R13,SAVEAREA+4   SAVE CALLING PGMS SAVEAREA ADDRESS      00007600
         LR    R2,R13           SAVE CALLING PGMS SAVEAREA ADDRESS      00007700
         LA    R13,SAVEAREA     R13 IS ADDRESS OF THIS PGMS SAVEAREA    00007800
         ST    R13,8(R2)        STORE ADDRESS IN CALLING PGMS SAVEAREA  00007900
         STM   R10,R12,BASEADDR SAVE BASE REGISTERS FOR EXIT ROUTINES   00008000
         USING IFGRPL,R9        R9 IS BASE FOR RPL                      00008100
         USING ISTRPL6X,R8      R8 IS BASE FOR RPL EXTENSION            00008200
*                                                                       00008300
         ST    R1,CPPL_ADDRESS  SAVE ADDRESS OF THE CPPL                00008400
*                                                                       00008500
         BAL   R14,GETPARM      GET THE EXEC PARM                       00008600
*                                                                       00008700
         CLI   OKAY,C'Y'        OKAY?                                   00008800
         BNE   TERMRTN          NO, EXIT                                00008900
*                                                                       00009000
         BAL   R14,INITRTN      PERFORM INITIALIZATION                  00009100
*                                                                       00009200
         CLI   OKAY,C'Y'        OKAY?                                   00009300
         BNE   TERMRTN          NO, EXIT                                00009400
*                                                                       00009500
MAINLINE EQU   *                                                        00009600
*                                                                       00009700
         BAL   R14,MAINRTN      PERFORM MAINLINE PROCESSING             00009800
*                                                                       00009900
TERMRTN  EQU   *                                                        00010000
         L     R13,SAVEAREA+4   RESTORE CALLING PGMS SAVEAREA           00010100
         RETURN (14,12),RC=0    RESTORE CALLING PGMS REGS AND RETURN    00010200
         EJECT                                                          00010300
*********************************************************************** 00010400
*********************************************************************** 00010500
***                                                                 *** 00010600
***  This is the mainline routine.  Routines are called to:         *** 00010700
***                                                                 *** 00010800
***    1. Allocate a conversation with NetView                      *** 00010900
***    2. Send the command to NetView to be executed                *** 00011000
***    3. Receive the response(s) from NetView                      *** 00011100
***                                                                 *** 00011200
***    To wait for the receive, a 15 second timer is issued.  A     *** 00011300
***    WAIT is then issued to wait on the receive or the timer.     *** 00011400
***    If the receive does not get satisified within 15 seconds,    *** 00011500
***    an error message is displayed and the command ends.          *** 00011600
***                                                                 *** 00011700
***    When the receive is satisfied, a routine is called to parse  *** 00011800
***    the buffer received.  The buffer may contain the command     *** 00011900
***    response or a SNACR.  If the buffer contains a response from *** 00012000
***    the command, it is displayed.  If the buffer contains a      *** 00012100
***    SNACR this indicates a error occurred.  A error message is   *** 00012200
***    displayed which has the SNACR sense code.                    *** 00012300
***                                                                 *** 00012400
*********************************************************************** 00012500
*********************************************************************** 00012600
MAINRTN  EQU   *                                                        00012700
         ST    R14,RMAINRTN     SAVE RETURN ADDRESS                     00012800
*                                                                       00012900
         BAL   R14,ALLOC         ALLOCATE A CONVERSATION                00013000
*                                                                       00013100
         CLI   OKAY,C'Y'         EVERYTHING OKAY?                       00013200
         BNE   MAINRTN7          NO, EXIT                               00013300
*                                                                       00013400
         BAL   R14,SEND          SEND THE COMMAND                       00013500
*                                                                       00013600
         CLI   OKAY,C'Y'         EVERYTHING OKAY?                       00013700
         BNE   MAINRTN7          NO, EXIT                               00013800
*                                                                       00013900
         MVC   BUFFADDR,=A(RECVREC)                                     00014000
         MVC   BUFFSIZE,=A(RECVRECL)                                    00014100
*                                                                       00014200
MAINRTN1 EQU   *                                                        00014300
*                                                                       00014400
         BAL   R14,RECEIVE       ISSUE THE RECEIVE                      00014500
*                                                                       00014600
         CLI   OKAY,C'Y'         EVERYTHING OKAY?                       00014700
         BNE   MAINRTN7          NO, CLOSE ACB AND EXIT                 00014800
*                                                                       00014900
         TM    RECVECB,X'40'     RECEIVE ALREADY POSTED?                00015000
         BO    MAINRTN3          YES, GO PROCESS THE RECEIVE            00015100
*                                                                       00015200
         XC    TIMEECB,TIMEECB   CLEAR TIMER ECB                        00015300
*                                                                       00015400
         STIMER REAL,STIMERX,BINTVL=WAITTIME                            00015500
*                                                                       00015600
         WAIT  ECBLIST=ECBLIST   WAIT FOR RECEIVE OR STIMER             00015700
*                                                                       00015800
         TM    RECVECB,X'40'     RECEIVE POSTED?                        00015900
         BO    MAINRTN2          YES, CONTINUE                          00016000
*                                                                       00016100
         MVC   MESSAGE(ERRMSG6L),ERRMSG6                                00016200
         BAL   R14,PUTLINE       DISPLAY ERROR MESSAGE                  00016300
*                                                                       00016400
         MVI   OKAY,C'N'         INDICATE AN ERROR                      00016500
*                                                                       00016600
         B     MAINRTN7          CLOSE ACB AND EXIT                     00016700
*                                                                       00016800
MAINRTN2 EQU   *                                                        00016900
*                                                                       00017000
         TTIMER CANCEL           CANCEL TIMER                           00017100
*                                                                       00017200
MAINRTN3 EQU   *                                                        00017300
*                                                                       00017400
         LA    R8,RPL2X          GET ADDRESS OF RPL EXTENSION           00017500
         LA    R9,RPL2           GET ADDRESS OF RPL                     00017600
*                                                                       00017700
         APPCCMD CONTROL=CHECK,RPL=RPL2                                 00017800
*                                                                       00017900
         LTR   R15,R15           GENERAL RETURN CODE OKAY?              00018000
         BNZ   MAINRTN4          NO, DISPLAY ERROR MESSAGE              00018100
*                                                                       00018200
         LTR   R0,R0             CONDITIONAL COMPLETION OKAY?           00018300
         BZ    MAINRTN5          NO, CONTINUE                           00018400
*                                                                       00018500
MAINRTN4 EQU   *                                                        00018600
*                                                                       00018700
         MVC   CONTROL,=CL8'CHECK'                                      00018800
         MVC   QUALIFY,=CL8' '                                          00018900
         BAL   R14,LU62ERR       GO DISPLAY THE ERROR                   00019000
*                                                                       00019100
         B     MAINRTN7          CLOSE ACB AND EXIT                     00019200
*                                                                       00019300
MAINRTN5 EQU   *                                                        00019400
*                                                                       00019500
         TM    RPL6RCV1,RPL6WDAC DATA COMPLETE?                         00019600
         BO    MAINRTN6          YES, CONTINUE                          00019700
*                                                                       00019800
         BAL   R14,CHKRECV       CHECK TO SEE WHAT WAS RECEIVED         00019900
*                                                                       00020000
         CLI   OKAY,C'Y'         OKAY?                                  00020100
         BNE   MAINRTN7          NO, CLOSE ACB AND EXIT                 00020200
*                                                                       00020300
         TM    RPL6RCV1,RPL6WDAI DATA INCOMPLETE?                       00020400
         BO    MAINRTN1          YES, GO ISSUE ANOTHER RECEIVE          00020500
*                                                                       00020600
         B     MAINRTN7          CLOSE ACB AND EXIT                     00020700
*                                                                       00020800
MAINRTN6 EQU   *                                                        00020900
*                                                                       00021000
         BAL   R14,PARSE         PARSE THE BUFFER AND DISPLAY RESULT    00021100
*                                                                       00021200
MAINRTN7 EQU   *                                                        00021300
*                                                                       00021400
         CLOSE VTAMACB           CLOSE ACB                              00021500
*                                                                       00021600
MAINRTNX EQU   *                                                        00021700
         L     R14,RMAINRTN      RESTORE RETURN ADDRESS                 00021800
         BR    R14               RETURN                                 00021900
         EJECT                                                          00022000
*********************************************************************** 00022100
*********************************************************************** 00022200
***                                                                 *** 00022300
*** This routine issues a APPCCMD CONTROL=OPRCNTL,QUALIFY=CNOS      *** 00022400
*** to cause VTAM to add a entry to the VTAM (LU,Mode) table.       *** 00022500
***                                                                 *** 00022600
*** The VTAM (LU,Mode) table contains information about the partner *** 00022700
*** LU: (local LU name, network qualified LU name, uninterpreted    *** 00022800
*** LU name, parallel session capability, and a list of mode        *** 00022900
*** descriptions).                                                  *** 00023000
***                                                                 *** 00023100
*** If the APPCCMD CONTROL=OPRCNTL,QUALIFY=CNOS is successful,      *** 00023200
*** a APPCCMD CONTROL=ALLOC,QUALIFY=ALLOCD is issued to allocate    *** 00023300
*** a LU 6.2 conversation with NetView.                             *** 00023400
***                                                                 *** 00023500
*** If the APPCCMD CONTROL=ALLOC,QUALIFY=ALLOCD is successful,      *** 00023600
*** the LU 6.2 conversation ID is saved and will be used when       *** 00023700
*** the SEND is issued to send the command to NetView.  Then        *** 00023800
*** a routine is called to get the network ID of the destination    *** 00023900
*** LU (NetView).                                                   *** 00024000
***                                                                 *** 00024100
*********************************************************************** 00024200
*********************************************************************** 00024300
ALLOC    EQU   *                                                        00024400
         ST    R14,RALLOC        SAVE RETURN ADDRESS                    00024500
*                                                                       00024600
         MVI   OKAY,C'Y'         INITIALIZE OKAY SWITCH                 00024700
*                                                                       00024800
         LA    R8,RPL1X          GET ADDRESS OF RPL EXTENSION           00024900
         LA    R9,RPL1           GET ADDRESS OF RPL                     00025000
*                                                                       00025100
         MVC   RPL6LU,NETVIEW    PUT LU NAME IN RPL EXTENSION           00025200
*                                                                       00025300
         LA    R1,CNOSAREA       GET ADDRESS OF CNOS AREA               00025400
         USING ISTSLCNS,R1       R1 IS BASE REGISTER                    00025500
         MVC   SLCSESSL,=H'2'    SET MAXIMUM SESSION LEVEL              00025600
         MVC   SLCMCWL,=H'1'     # OF CONTENTION WINNER SESSIONS (LOCAL 00025700
         MVC   SLCMCWP,=H'1'     # OF CONTENTION WINNER SESSIONS (TARG  00025800
         MVI   SLCPARMS,X'00'    CLEAR CNOS PARAMETERS                  00025900
*                                                                       00026000
*                                '0xxxxxxx' Source side cannot drain    00026100
*                                           it's allocation requests    00026200
*                                'x0xxxxxx' Target side can't drain     00026300
*                                           it's allocation requests    00026400
*                                'xx0xxxxx' Source side is responsible  00026500
*                                           for deactivating sessions   00026600
*                                'xxx0xxxx' Specifies that the session  00026700
*                                           limit and contention-winner 00026800
*                                           polarity values for only    00026900
*                                           the mode name specified in  00027000
*                                           the LOGMODE field are to be 00027100
*                                           reset to 0.                 00027200
*                                'xxxx0xxx' Specifies that the partner  00027300
*                                           LU supports parallel        00027400
*                                           sessions and CNOS exchanges 00027500
*                                'xxxxx0xx' Indicates that the LU will  00027600
*                                           not accept FMH-5s that      00027700
*                                           include security fields     00027800
*                                                                       00027900
         DROP  R1                                                       00028000
*                                                                       00028100
         APPCCMD CONTROL=OPRCNTL,                                      *00028200
               QUALIFY=CNOS,                                           *00028300
               RPL=RPL1,                                               *00028400
               OPTCD=SYN,                                              *00028500
               LOGMODE=PARALLEL,                                       *00028600
               AREA=CNOSAREA,                                          *00028700
               RECLEN=7                                                 00028800
*                                                                       00028900
         LTR   R15,R15           GENERAL RETURN CODE OKAY?              00029000
         BNZ   ALLOC1            NO, CONTINUE                           00029100
*                                                                       00029200
         LTR   R0,R0             SPECIFIC RETURN CODE OKAY?             00029300
         BZ    ALLOC3            YES, GO DO A ALLOC                     00029400
*                                                                       00029500
ALLOC1   EQU   *                                                        00029600
*                                                                       00029700
         CLC   RPL6RCPR,=AL2(USF6OK)                                    00029800
         BNE   ALLOC2                                                   00029900
*                                                                       00030000
         CLC   RPL6RCSC,=AL2(USF6ASSP)                                  00030100
         BE    ALLOC3                                                   00030200
*                                                                       00030300
         CLC   RPL6RCSC,=AL2(USF6ASNG)                                  00030400
         BE    ALLOC3                                                   00030500
*                                                                       00030600
ALLOC2   EQU   *                                                        00030700
*                                                                       00030800
         MVC   CONTROL,=CL8'OPRCNTL'                                    00030900
         MVC   QUALIFY,=CL8'CNOS'                                       00031000
         BAL   R14,LU62ERR       GO DISPLAY THE ERROR                   00031100
*                                                                       00031200
         B     ALLOCX            EXIT                                   00031300
*                                                                       00031400
ALLOC3   EQU   *                                                        00031500
*                                                                       00031600
         APPCCMD CONTROL=ALLOC,                                        *00031700
               QUALIFY=ALLOCD,                                         *00031800
               RPL=RPL1,                                               *00031900
               OPTCD=SYN,                                              *00032000
               AREA=FMH5,                                              *00032100
               RECLEN=FMH5LEN,                                         *00032200
               LOGMODE=PARALLEL                                         00032300
*                                                                       00032400
         LTR   R15,R15           GENERAL RETURN CODE OKAY?              00032500
         BNZ   ALLOC4            NO, DISPLAY ERROR MESSAGE              00032600
*                                                                       00032700
         LTR   R0,R0             CONDITIONAL COMPLETION OKAY?           00032800
         BZ    ALLOC5            YES, CONTINUE                          00032900
*                                                                       00033000
ALLOC4   EQU   *                                                        00033100
*                                                                       00033200
         MVC   CONTROL,=CL8'ALLOC'                                      00033300
         MVC   QUALIFY,=CL8'ALLOCD'                                     00033400
         BAL   R14,LU62ERR       GO DISPLAY THE ERROR                   00033500
         B     ALLOCX            EXIT                                   00033600
*                                                                       00033700
ALLOC5   EQU   *                                                        00033800
*                                                                       00033900
         MVC   SCONVID,RPL6CNVD  SAVE CONVERSATION ID                   00034000
*                                                                       00034100
         BAL   R14,GETDNET       GO GET NETWORK ID OF DESTINATION LU    00034200
*                                                                       00034300
ALLOCX   EQU   *                                                        00034400
         L     R14,RALLOC        RESTORE RETURN ADDRESS                 00034500
         BR    R14               RETURN                                 00034600
         EJECT                                                          00034700
*********************************************************************** 00034800
*********************************************************************** 00034900
***                                                                 *** 00035000
*** This routine issues a APPCCMD CONTROL=OPRCNTL,QUALIFY=DISPLAY   *** 00035100
*** to return information associated with the destination LU        *** 00035200
*** (NetView).  The information that is needed by this code is      *** 00035300
*** the network ID of NetView.  The fully qualified LU name         *** 00035400
*** for NetView is returned (format: networkid.luname).  The        *** 00035500
*** network ID is optional and may not be present.  The fully       *** 00035600
*** qualified lu name is parsed for the network ID and if the       *** 00035700
*** network ID is present, it is moved to the destination network   *** 00035800
*** ID subfield in the MDSMU.                                       *** 00035900
***                                                                 *** 00036000
*********************************************************************** 00036100
*********************************************************************** 00036200
GETDNET  EQU   *                                                        00036300
         ST    R14,RGETDNET      SAVE RETURN ADDRESS                    00036400
*                                                                       00036500
         APPCCMD CONTROL=OPRCNTL,QUALIFY=DISPLAY,                      *00036600
               RPL=RPL1,                                               *00036700
               OPTCD=SYN,                                              *00036800
               AREA=SLDAREA,                                           *00036900
               AREALEN=SLDLENG                                          00037000
*                                                                       00037100
         LTR   R15,R15           GENERAL RETURN CODE OKAY?              00037200
         BNZ   GETDNET1          NO, CONTINUE                           00037300
*                                                                       00037400
         LTR   R0,R0             ERROR CODE OKAY?                       00037500
         BZ    GETDNET2          YES, CONTINUE                          00037600
*                                                                       00037700
GETDNET1 EQU   *                                                        00037800
*                                                                       00037900
         MVC   CONTROL,=CL8'OPRCNTL'                                    00038000
         MVC   QUALIFY,=CL8'DISPLAY'                                    00038100
         BAL   R14,LU62ERR       GO DISPLAY THE ERROR                   00038200
         B     GETDNETX          EXIT                                   00038300
*                                                                       00038400
GETDNET2 EQU   *                                                        00038500
*                                                                       00038600
         LA    R1,SLDAREA        GET ADDRESS OF SLDAREA                 00038700
         USING ISTSLD,R1         R1 IS BASE REGISTER                    00038800
*                                                                       00038900
         CLI   SLDFQNLN,X'00'    FULLY QUALIFIED NAME AVAILABLE?        00039000
         BE    GETDNETX          NO, EXIT                               00039100
*                                                                       00039200
         LA    R2,SLDFQNAM       GET ADDRESS OF THE NAME                00039300
         LR    R3,R2             GET ADDRESS OF THE NAME                00039400
         LA    R4,8              NETID IS MAXIMUM 8 BYTES               00039500
         SLR   R5,R5             CLEAR FQNAME LENGTH REGISTR            00039600
         IC    R5,SLDFQNLN       GET LENGTH OF NAME                     00039700
         DROP  R1                                                       00039800
*                                                                       00039900
         CR    R4,R5             FQNAME < 8?                            00040000
         BNH   GETDNET3          NO, CONTINUE                           00040100
*                                                                       00040200
         LR    R4,R5             YES, GET SHORT LENGTH                  00040300
*                                                                       00040400
GETDNET3 EQU   *                                                        00040500
*                                                                       00040600
         CLI   0(R2),C'.'        END OF NETID?                          00040700
         BE    GETDNET4          YES, CONTINUE                          00040800
*                                                                       00040900
         LA    R2,1(R2)          INCREMENT TO NEXT INPUT BYTE           00041000
*                                                                       00041100
         BCTR  R5,0              DECREMENT LENGTH OF FQNAME             00041200
         BCT   R4,GETDNET3       CHECK MAXIMUM 8 BYTES FOR NETWORK ID   00041300
*                                                                       00041400
         LTR   R5,R5             ANY MORE DATA?                         00041500
         BZ    GETDNETX          NO, EXIT                               00041600
*                                                                       00041700
         CLI   0(R2),C'.'        YES, IS NEXT BYTE A PERIOD?            00041800
         BNE   GETDNETX          NO, EXIT                               00041900
*                                                                       00042000
GETDNET4 EQU   *                                                        00042100
*                                                                       00042200
         SR    R2,R3             GET LENGTH OF NETWORK ID               00042300
         BCTR  R2,0              MAKE LENGTH EXECUTEABLE                00042400
         EX    R2,MVENETID       GO GET NETWORK ID                      00042500
*                                                                       00042600
GETDNETX EQU   *                                                        00042700
         L     R14,RGETDNET      RESTORE RETURN ADDRESS                 00042800
         BR    R14               RETURN                                 00042900
*                                                                       00043000
MVENETID MVC   DLUNETID(0),0(R3) MOVE NETWORK ID TO DEST. NETWORK ID    00043100
         EJECT                                                          00043200
*********************************************************************** 00043300
*********************************************************************** 00043400
***                                                                 *** 00043500
*** This routine issues a APPCCMD CONTROL=DEALLOC,QUALIFY=DATACON   *** 00043600
*** to send the command to NetView.  This macro performs the        *** 00043700
*** following functions:                                            *** 00043800
***                                                                 *** 00043900
***   1. sends the command                                          *** 00044000
***   2. flushes the buffer                                         *** 00044100
***   3. waits for a confirmation                                   *** 00044200
***   4. deallocates the conversation                               *** 00044300
***                                                                 *** 00044400
*********************************************************************** 00044500
*********************************************************************** 00044600
SEND     EQU   *                                                        00044700
         ST    R14,RSEND         SAVE RETURN ADDRESS                    00044800
*                                                                       00044900
         BAL   R14,GETDATE       GET DATE AND TIME FOR CORRELATOR       00045000
*                                                                       00045100
         MVI   OKAY,C'Y'         INITIALIZE OKAY SWITCH                 00045200
*                                                                       00045300
         LH    R4,MDSMU          GET LENGTH OF MDSMU                    00045400
*                                                                       00045500
         APPCCMD CONTROL=DEALLOC,                                      *00045600
               QUALIFY=DATACON,                                        *00045700
               RPL=RPL1,                                               *00045800
               CONVID=SCONVID,                                         *00045900
               OPTCD=SYN,                                              *00046000
               AREA=MDSMU,                                             *00046100
               RECLEN=(4)                                               00046200
*                                                                       00046300
         LTR   R15,R15           GENERAL RETURN CODE OKAY?              00046400
         BNZ   SEND1             NO, DISPLAY ERROR MESSAGE              00046500
*                                                                       00046600
         LTR   R0,R0             CONDITIONAL COMPLETION OKAY?           00046700
         BZ    SENDX             YES, EXIT                              00046800
*                                                                       00046900
SEND1    EQU   *                                                        00047000
*                                                                       00047100
         LA    R8,RPL1X          GET ADDRESS OF RPL EXTENSION           00047200
         LA    R9,RPL1           GET ADDRESS OF RPL                     00047300
*                                                                       00047400
         MVC   CONTROL,=CL8'DEALLOC'                                    00047500
         MVC   QUALIFY,=CL8'DATACON'                                    00047600
         BAL   R14,LU62ERR       GO DISPLAY THE ERROR                   00047700
*                                                                       00047800
SENDX    EQU   *                                                        00047900
         L     R14,RSEND         RESTORE RETURN ADDRESS                 00048000
         BR    R14                                                      00048100
         EJECT                                                          00048200
*********************************************************************** 00048300
*********************************************************************** 00048400
***                                                                 *** 00048500
*** This routine issues a APPCCMD CONTROL=RECEIVE,QUALIFY=ANY.      *** 00048600
*** The receive is asynchronous and is waited on in the mainline    *** 00048700
*** routine.  When the receive is posted the buffer will contain    *** 00048800
*** the command response or a SNACR indicating an error.            *** 00048900
***                                                                 *** 00049000
*********************************************************************** 00049100
*********************************************************************** 00049200
RECEIVE  EQU   *                                                        00049300
         ST    R14,RRECEIVE      SAVE RETURN ADDRESS                    00049400
*                                                                       00049500
         MVI   OKAY,C'Y'         INITIALIZE OKAY SWITCH                 00049600
*                                                                       00049700
         XC    RECVECB,RECVECB   CLEAR RECEIVE ECB                      00049800
*                                                                       00049900
         L     R2,BUFFADDR                                              00050000
         L     R3,BUFFSIZE                                              00050100
*                                                                       00050200
         C     R2,=A(RECVREC)    1ST RECEIVE FOR MESSAGE?               00050300
         BE    RECEIVE1          YES, CONTINUE                          00050400
*                                                                       00050500
         LA    R2,4(R2)          NO, INCREMENT PAST HEADER              00050600
         SH    R3,=H'4'          ADJUST LENGTH                          00050700
*                                                                       00050800
RECEIVE1 EQU   *                                                        00050900
*                                                                       00051000
         APPCCMD CONTROL=RECEIVE,                                      *00051100
               QUALIFY=ANY,                                            *00051200
               RPL=RPL2,                                               *00051300
               OPTCD=ASY,                                              *00051400
               ECB=RECVECB,                                            *00051500
               CONMODE=SAME,                                           *00051600
               AREALEN=(3),                                            *00051700
               AREA=(2)                                                 00051800
*                                                                       00051900
         LTR   R15,R15           GENERAL RETURN CODE OKAY?              00052000
         BNZ   RECEIVE2          NO, DISPLAY ERROR MESSAGE              00052100
*                                                                       00052200
         LTR   R0,R0             CONDITIONAL COMPLETION OKAY?           00052300
         BZ    RECEIVEX          YES, EXIT                              00052400
*                                                                       00052500
RECEIVE2 EQU   *                                                        00052600
*                                                                       00052700
         LA    R8,RPL2X          GET ADDRESS OF RPL EXTENSION           00052800
         LA    R9,RPL2           GET ADDRESS OF RPL                     00052900
*                                                                       00053000
         MVC   CONTROL,=CL8'RECEIVE'                                    00053100
         MVC   QUALIFY,=CL8'ANY'                                        00053200
         BAL   R14,LU62ERR       GO DISPLAY THE ERROR                   00053300
*                                                                       00053400
RECEIVEX EQU   *                                                        00053500
         L     R14,RRECEIVE      RESTORE RETURN ADDRESS                 00053600
         BR    R14               RETURN                                 00053700
         EJECT                                                          00053800
*********************************************************************** 00053900
*********************************************************************** 00054000
***                                                                 *** 00054100
*** This routine parses the receive buffer.                         *** 00054200
***                                                                 *** 00054300
*********************************************************************** 00054400
*********************************************************************** 00054500
PARSE    EQU   *                                                        00054600
         ST    R14,RPARSE        SAVE RETURN ADDRESS                    00054700
*                                                                       00054800
         LA    R8,RPL2X          GET ADDRESS OF RPL EXTENSION           00054900
         LA    R9,RPL2           GET ADDRESS OF RPL                     00055000
*                                                                       00055100
         TM    RPL6RCV1,RPL6WCFM CONFIRMATION REQUESTED?                00055200
         BZ    PARSE1            NO, CONTINUE                           00055300
*                                                                       00055400
         BAL   R14,SENDCON       YES, GO SEND CONFIRMATION              00055500
*                                                                       00055600
PARSE1   EQU   *                                                        00055700
*                                                                       00055800
         L     R2,BUFFADDR       GET ADDRESS OF BUFFER                  00055900
*                                                                       00056000
         CLC   0(2,R2),=H'8'     AT LEAST 8 BYTES RETURNED?             00056100
         BL    PARSEX            NO, EXIT                               00056200
*                                                                       00056300
         CLC   2(2,R2),=X'1310'  MDSMU?                                 00056400
         BNE   PARSEX            NO, EXIT                               00056500
*                                                                       00056600
         LH    R3,0(R2)          GET LENGTH OF MDSMU                    00056700
         LH    R4,0(R2)          GET LENGTH OF MDSMU                    00056800
         AR    R4,R2             GET END OF RECORD                      00056900
         LA    R2,4(R2)          BUMP PAST MDSMU LENGTH + KEY           00057000
         SH    R3,=H'4'          ADJUST LENGTH                          00057100
*                                                                       00057200
PARSE2   EQU   *                                                        00057300
*                                                                       00057400
         CLC   0(2,R2),=H'0'     ZERO MAJOR VECTOR LENGTH?              00057500
         BE    PARSEX            YES, EXIT                              00057600
*                                                                       00057700
         CLC   2(2,R2),=X'1212'  CP_MSU MAJOR VECTOR?                   00057800
         BE    PARSE3            YES, CONTINUE                          00057900
*                                                                       00058000
         CLC   2(2,R2),=X'1532'  SNACR MAJOR VECTOR?                    00058100
         BNE   PARSE4            NO, CONTINUE                           00058200
*                                                                       00058300
         BAL   R14,P1532MV       GO PARSE THE SNACR AND DISPLAY SENSE   00058400
*                                                                       00058500
         B     PARSEX            EXIT                                   00058600
*                                                                       00058700
PARSE3   EQU   *                                                        00058800
*                                                                       00058900
         BAL   R14,P1212MV       GO PARSE THE X'1212' MAJOR VECTOR      00059000
*                                                                       00059100
PARSE4   EQU   *                                                        00059200
*                                                                       00059300
         MVC   HALFWORD,0(R2)    GET LENGTH OF MDSMU ROUTING INFO       00059400
*                                                                       00059500
         SH    R3,HALFWORD       DECRMENT TOTAL MDSMU LENGTH            00059600
         BM    PARSEX            IF NEGATIVE EXIT                       00059700
*                                                                       00059800
         AH    R2,HALFWORD       POINT TO NEXT MAJOR VECTOR             00059900
*                                                                       00060000
         CR    R2,R4             PAST END OF MDSMU?                     00060100
         BL    PARSE2            NO, KEEP CHECKING                      00060200
*                                                                       00060300
         L     R1,BUFFADDR       GET BUFFER ADDRESS                     00060400
         L     R0,BUFFSIZE       GET BUFFER SIZE                        00060500
*                                                                       00060600
         FREEMAIN RC,LV=(0),A=(1) FREE THE BUFFER                       00060700
         LTR   R15,R15           OKAY?                                  00060800
         BZ    PARSE5            YES, CONTINUE                          00060900
*                                                                       00061000
         MVI   OKAY,C'N'         INDICATE AN ERROR                      00061100
*                                                                       00061200
         MVC   MESSAGE(ERRMSG15L),ERRMSG15                              00061300
         BAL   R14,PUTLINE       DISPLAY ERROR MESSAGE                  00061400
*                                                                       00061500
         B     PARSEX            EXIT                                   00061600
*                                                                       00061700
PARSE5   EQU   *                                                        00061800
*                                                                       00061900
         MVC   BUFFADDR,=A(RECVREC)                                     00062000
         MVC   BUFFSIZE,=A(RECVRECL)                                    00062100
*                                                                       00062200
PARSEX   EQU   *                                                        00062300
         L     R14,RPARSE        RESTORE RETURN ADDRESS                 00062400
         BR    R14               RETURN                                 00062500
         EJECT                                                          00062600
*********************************************************************** 00062700
*********************************************************************** 00062800
***                                                                 *** 00062900
*** This routine extracts the command response from the user GDS    *** 00063000
*** variable and displays it to the TSO user.                       *** 00063100
***                                                                 *** 00063200
*********************************************************************** 00063300
*********************************************************************** 00063400
P1212MV  EQU   *                                                        00063500
         ST    R14,RP1212MV      SAVE RETURN ADDRESS                    00063600
*                                                                       00063700
         XC    MESSAGE+2(2),MESSAGE+2                                   00063800
*                                                                       00063900
         STM   R2,R3,SAVER2R3    SAVE REGS 2 AND 3                      00064000
*                                                                       00064100
         LR    R3,R2             GET START OF BUFFER                    00064200
*                                                                       00064300
         MVC   HALFWORD,0(R3)    GET LENGTH OF BUFFER                   00064400
         AH    R3,HALFWORD       GET END OF BUFFER                      00064500
*                                                                       00064600
         C     R3,BUFFEND        PAST END OF BUFFER?                    00064700
         BNH   P1212MV0          NO, CONTINUE                           00064800
*                                                                       00064900
         L     R3,BUFFEND        GET END OF BUFFER?                     00065000
*                                                                       00065100
P1212MV0 EQU   *                                                        00065200
*                                                                       00065300
         LA    R2,4(R2)          INCREMENT PAST GDS X'1212' HEADER      00065400
*                                                                       00065500
         CLC   2(2,R2),=X'0061'  REPLY TO EXECUTE COMMAND?              00065600
         BNE   P1212MVX          NO, EXIT                               00065700
*                                                                       00065800
         LA    R2,4(R2)          INCREMENT PAST GDS X'0061' HEADER      00065900
*                                                                       00066000
         CLC   2(2,R2),=X'1300'  TEXT DATA PARAMETER MAJOR VECTOR?      00066100
         BNE   P1212MVX          NO, EXIT                               00066200
*                                                                       00066300
         LA    R2,4(R2)          INCREMENT PAST GDS X'1300' HEADER      00066400
*                                                                       00066500
P1212MV1 EQU   *                                                        00066600
*                                                                       00066700
         CR    R2,R3             ANY MORE DATA?                         00066800
         BNL   P1212MV3          NO, EXIT                               00066900
*                                                                       00067000
         SLR   R1,R1             CLEAR LENGTH REGISTER                  00067100
         IC    R1,0(R2)          GET LENGTH                             00067200
*                                                                       00067300
         CLI   1(R2),X'31'       IS IT A SV31?                          00067400
         BNE   P1212MV2          NO, MUST HAVE BEEN TRUNCATED           00067500
*                                                                       00067600
         LR    R15,R2            GET START ADDRESS                      00067700
         AR    R15,R1            ADD THE LENGTH                         00067800
         CR    R15,R3            PAST THE END?                          00067900
         BH    P1212MV2          YES, MUST HAVE BEEN TRUNCATED          00068000
*                                                                       00068100
         LA    R1,2(R1)          ADD 2 FOR RESERVED BYTES               00068200
         STH   R1,MESSAGE                                               00068300
*                                                                       00068400
         SH    R1,=H'5'          GET LENGTH FOR MOVE (EXECUTE FORM)     00068500
*                                                                       00068600
         EX    R1,MOVEMSG        MOVE MESSAGE TO PUTLINE BUFFER         00068700
*                                                                       00068800
         BAL   R14,PUTLINE       DISPLAY THE LINE                       00068900
*                                                                       00069000
         SLR   R1,R1             CLEAR LENGTH REGISTER                  00069100
         IC    R1,0(R2)          GET LENGTH                             00069200
         AR    R2,R1             INCREMENT PAST MESSAGE                 00069300
*                                                                       00069400
         B     P1212MV1          KEEP GOING                             00069500
*                                                                       00069600
P1212MV2 EQU   *                                                        00069700
*                                                                       00069800
         MVC   MESSAGE(ERRMSG99L),ERRMSG99                              00069900
*                                                                       00070000
         BAL   R14,PUTLINE       DISPLAY THE LINE                       00070100
*                                                                       00070200
         SLR   R4,R4             ALL DONE                               00070300
*                                                                       00070400
P1212MV3 EQU   *                                                        00070500
*                                                                       00070600
         LM    R2,R3,SAVER2R3    RESTORE REGS 2 AND 3                   00070700
*                                                                       00070800
P1212MVX EQU   *                                                        00070900
         L     R14,RP1212MV      RESTORE RETURN ADDRESS                 00071000
         BR    R14               RETURN                                 00071100
*                                                                       00071200
MOVEMSG  MVC   MESSAGE+4(0),2(R2)                                       00071300
*                                                                       00071400
         EJECT                                                          00071500
*********************************************************************** 00071600
*********************************************************************** 00071700
***                                                                 *** 00071800
*** This routine parses the SNACR GDS variable and extracts the     *** 00071900
*** sense code and displays it in an error message.                 *** 00072000
***                                                                 *** 00072100
*********************************************************************** 00072200
*********************************************************************** 00072300
P1532MV  EQU   *                                                        00072400
         ST    R14,RP1532MV      SAVE RETURN ADDRESS                    00072500
*                                                                       00072600
         MVI   OKAY,C'Y'         SET ERROR FLAG                         00072700
*                                                                       00072800
         LA    R1,4(R2)          INCREMENT PAST SNACR KEY AND LENGTH    00072900
         MVC   HALFWORD,0(R2)    GET LENGTH OF X'1532'                  00073000
         LR    R15,R2            GET ADDRESS OF X'1532'                 00073100
         AH    R15,HALFWORD      GET END OF X'1532'                     00073200
*                                                                       00073300
P1532MV1 EQU   *                                                        00073400
*                                                                       00073500
         CLI   1(R1),X'7D'       SENSE CODE?                            00073600
         BE    P1532MV2          YES, GO GET SENSE CODE                 00073700
*                                                                       00073800
         SLR   R0,R0             CLEAR LENGTH REGISTER                  00073900
         IC    R0,0(R1)          GET LENGTH OF SUBVECTOR                00074000
*                                                                       00074100
         LTR   R0,R0             ZERO LENGTH SUBVECTOR?                 00074200
         BZ    P1532MVX          YES, EXIT                              00074300
*                                                                       00074400
         AR    R1,R0             INCREMENT TO NEXT SUBVECTOR            00074500
         CR    R1,R15            END OF SNACR MAJOR VECTOR              00074600
         BL    P1532MV1          NO, KEEP CHECKING                      00074700
*                                                                       00074800
         B     P1532MVX          NO, EXIT                               00074900
*                                                                       00075000
P1532MV2 EQU   *                                                        00075100
*                                                                       00075200
         MVC   SENSE,2(R1)       GET SENSE CODE                         00075300
         LA    R1,SENSE                                                 00075400
         LA    R2,ERRSENSE                                              00075500
         LA    R3,4                                                     00075600
         BAL   R14,HEXCONV       CONVERT SENSE CODE TO PRINTABLE        00075700
*                                                                       00075800
         MVC   MESSAGE(ERRMSG7L),ERRMSG7                                00075900
         BAL   R14,PUTLINE       DISPLAY ERROR MESSAGE                  00076000
*                                                                       00076100
P1532MVX EQU   *                                                        00076200
         L     R14,RP1532MV      RESTORE RETURN ADDRESS                 00076300
         BR    R14               RETURN                                 00076400
         EJECT                                                          00076500
*********************************************************************** 00076600
*********************************************************************** 00076700
***                                                                 *** 00076800
*** This routine issues a APPCCMD CONTROL=SEND,QUALIFY=CONFRMD      *** 00076900
*** which sends a confirmaton back to NetView.  High Performance    *** 00077000
*** applications issue the 1st send asking for a confirmation       *** 00077100
*** (definite response).  Subsequent sends after that are           *** 00077200
*** exception response.                                             *** 00077300
***                                                                 *** 00077400
*********************************************************************** 00077500
*********************************************************************** 00077600
SENDCON  EQU   *                                                        00077700
         ST    R14,RSENDCON      SAVE RETURN ADDRESS                    00077800
*                                                                       00077900
         APPCCMD CONTROL=SEND,                                         *00078000
               QUALIFY=CONFRMD,                                        *00078100
               RPL=RPL2,                                               *00078200
               OPTCD=SYN                                                00078300
*                                                                       00078400
         LTR   R15,R15           GENERAL RETURN CODE OKAY?              00078500
         BNZ   SENDCON1          NO, DISPLAY ERROR MESSAGE              00078600
         LTR   R0,R0             CONDITIONAL COMPLETION OKAY?           00078700
         BZ    SENDCONX          YES, EXIT                              00078800
*                                                                       00078900
SENDCON1 EQU   *                                                        00079000
*                                                                       00079100
         LA    R8,RPL2X          GET ADDRESS OF RPL EXTENSION           00079200
         LA    R9,RPL2           GET ADDRESS OF RPL                     00079300
*                                                                       00079400
         MVC   CONTROL,=CL8'SEND'                                       00079500
         MVC   QUALIFY,=CL8'CONFRMD'                                    00079600
         BAL   R14,LU62ERR       GO DISPLAY THE ERROR                   00079700
*                                                                       00079800
SENDCONX EQU   *                                                        00079900
         L     R14,RSENDCON      RESTORE RETURN ADDRESS                 00080000
         BR    R14                                                      00080100
         EJECT                                                          00080200
*********************************************************************** 00080300
*********************************************************************** 00080400
***                                                                 *** 00080500
*** This routine gets called when a RECEIVE is posted but for       *** 00080600
*** something other than "DATA_COMPLETE".  The reason is determined *** 00080700
*** and then the appropriate error message is displayed.            *** 00080800
***                                                                 *** 00080900
*********************************************************************** 00081000
*********************************************************************** 00081100
CHKRECV  EQU   *                                                        00081200
         ST    R14,RCHKRECV      SAVE RETURN ADDRESS                    00081300
*                                                                       00081400
         TM    RPL6RCV1,RPL6WDAI DATA INCOMPLETE?                       00081500
         BO    CHKRECV2          YES, GO ISSUE ANOTHER RECEIVE          00081600
*                                                                       00081700
         MVC   MESSAGE(ERRMSG9L),ERRMSG9                                00081800
*                                                                       00081900
         TM    RPL6RCV1,RPL6WDAT DATA?                                  00082000
         BO    CHKRECV1          YES, GO DISPLAY ERROR MESSAGE          00082100
*                                                                       00082200
         MVC   MESSAGE(ERRMSG10L),ERRMSG10                              00082300
*                                                                       00082400
         TM    RPL6RCV1,RPL6WSND SEND?                                  00082500
         BO    CHKRECV1          YES, GO DISPLAY ERROR MESSAGE          00082600
*                                                                       00082700
         MVC   MESSAGE(ERRMSG12L),ERRMSG12                              00082800
*                                                                       00082900
         TM    RPL6RCV1,RPL6WDAL DEALLOCATE?                            00083000
         BO    CHKRECV1          YES, GO DISPLAY ERROR MESSAGE          00083100
*                                                                       00083200
         MVC   MESSAGE(ERRMSG13L),ERRMSG13                              00083300
*                                                                       00083400
         TM    RPL6RCV1,RPL6WLOG LOG DATA?                              00083500
         BO    CHKRECV1          YES, GO DISPLAY ERROR MESSAGE          00083600
*                                                                       00083700
         MVC   MESSAGE(ERRMSG11L),ERRMSG11                              00083800
*                                                                       00083900
         TM    RPL6RCV1,RPL6WCFM CONFIRMATION?                          00084000
         BNO   CHKRECVX          NO, EXIT                               00084100
*                                                                       00084200
CHKRECV1 EQU   *                                                        00084300
*                                                                       00084400
         BAL   R14,PUTLINE       DISPLAY ERROR MESSAGE                  00084500
*                                                                       00084600
         B     CHKRECVX          EXIT                                   00084700
*                                                                       00084800
CHKRECV2 EQU   *                                                        00084900
*                                                                       00085000
         TTIMER CANCEL           CANCEL TIMER                           00085100
*                                                                       00085200
         LH    R1,RECVREC        GET LENGTH OF BUFFER                   00085300
         ST    R1,BUFFSIZE       SAVE LENGTH                            00085400
*                                                                       00085500
         GETMAIN RC,LV=(1)       GET STORAGE FOR BUFFER                 00085600
         LTR   R15,R15           DID I GET THE STORAGE?                 00085700
         BZ    CHKRECV3          YES, CONTINUE                          00085800
*                                                                       00085900
         MVI   OKAY,C'N'         INDICATE AN ERROR                      00086000
*                                                                       00086100
         MVC   MESSAGE(ERRMSG14L),ERRMSG14                              00086200
         BAL   R14,PUTLINE       DISPLAY ERROR MESSAGE                  00086300
*                                                                       00086400
         B     CHKRECVX          EXIT                                   00086500
*                                                                       00086600
CHKRECV3 EQU   *                                                        00086700
*                                                                       00086800
         ST    R1,BUFFADDR       SAVE STORAGE ADDRESS                   00086900
*                                                                       00087000
         MVC   0(4,R1),RECVREC   GET MDS HEADER                         00087100
*                                                                       00087200
         A     R1,BUFFSIZE       CALCULATE END ADDRESS                  00087300
         ST    R1,BUFFEND        SAVE END ADDRESS                       00087400
*                                                                       00087500
CHKRECVX EQU   *                                                        00087600
         L     R14,RCHKRECV      RESTORE RETURN ADDRESS                 00087700
         BR    R14                                                      00087800
         EJECT                                                          00087900
*********************************************************************** 00088000
*********************************************************************** 00088100
***                                                                 *** 00088200
*** This routine gets called before the SEND is issued and it       *** 00088300
*** gets the current date and time to be used for the Agent Unit    *** 00088400
*** Of Work correlator in the MDSMU.  The date and time are         *** 00088500
*** returned in packed decimal format via the TIME macro.           *** 00088600
***                                                                 *** 00088700
*** The time is returned in R0 in the format hhmmsshh.              *** 00088800
***                                                                 *** 00088900
***     where:                                                      *** 00089000
***           hh = hours in decimal                                 *** 00089100
***           mm = minutes in decimal                               *** 00089200
***           ss = seconds in decimal                               *** 00089300
***           hh = hundreds of seconds in decimal                   *** 00089400
***                                                                 *** 00089500
*** The date is returned in R1 in the format 0cyydddF (julian).     *** 00089600
***                                                                 *** 00089700
***     where:                                                      *** 00089800
***            c = 0 for years 1900-1999                            *** 00089900
***            c = 1 for years 2000-2999                            *** 00090000
***           yy = year                                             *** 00090100
***          ddd = days                                             *** 00090200
***            F = sign (makes it easy to unpack)                   *** 00090300
***                                                                 *** 00090400
*** The individual fields in the time must be converted to          *** 00090500
*** binary and then stored in the AUOW correlator.                  *** 00090600
***                                                                 *** 00090700
*** The julian date must be converted to gregorian mm/dd/yy.        *** 00090800
*** Then the 3 pieces of the gregorian date must be converted       *** 00090900
*** to binary and then stored in the AUOW correlator.               *** 00091000
***                                                                 *** 00091100
***                                                                 *** 00091200
***                                                                 *** 00091300
***                                                                 *** 00091400
*********************************************************************** 00091500
*********************************************************************** 00091600
GETDATE  EQU   *                                                        00091700
         ST    R14,RGETDATE                                             00091800
*                                                                       00091900
         TIME  DEC                          GET DATE AND TIME IN DEC    00092000
         ST    R0,TIME                      SAVE TIME                   00092100
         ST    R1,DATE                      SAVE DATE                   00092200
*                                                                       00092300
         UNPK  UNPKTIME,TIME(5)             UNPACK TIME                 00092400
*                                                                       00092500
         PACK  DBLEWORD,UNPKTIME(2)         GET HOUR                    00092600
         CVB   R2,DBLEWORD                  CONVERT TO BINARY           00092700
         STC   R2,SDTMHOUR                  PUT IN CORRELATOR           00092800
*                                                                       00092900
         PACK  DBLEWORD,UNPKTIME+2(2)       GET MINUTES                 00093000
         CVB   R2,DBLEWORD                  CONVERT TO BINARY           00093100
         STC   R2,SDTMMIN                   PUT IN CORRELATOR           00093200
*                                                                       00093300
         PACK  DBLEWORD,UNPKTIME+4(2)       GET SECONDS                 00093400
         CVB   R2,DBLEWORD                  CONVERT TO BINARY           00093500
         STC   R2,SDTMSEC                   PUT IN CORRELATOR           00093600
*                                                                       00093700
         PACK  DBLEWORD,UNPKTIME+6(2)       GET HUNDREDS OF SECONDS     00093800
         CVB   R2,DBLEWORD                  CONVERT TO BINARY           00093900
         STC   R2,SDTMHSEC                  PUT IN CORRELATOR           00094000
*                                                                       00094100
         ZAP   DAYS,DATE+2(2)               GET JULIAN DAYS             00094200
*                                                                       00094300
         ZAP   YEAR,DATE+1(3)               GET PACKED YYDDDF           00094400
         SP    YEAR,DATE+2(2)               SUBTRACT DAYS               00094500
         SRP   YEAR,61,0                    SHIFT RIGHT 3 POSITIONS     00094600
*                                                                       00094700
         AP    YEAR,=P'+1900'               MAKE IT 20TH CENTURY        00094800
*                                                                       00094900
         CLI   DATE,X'00'                   20TH CENTURY?               00095000
         BE    GETDATE1                     NO, CONTINUE                00095100
*                                                                       00095200
         AP    YEAR,=P'+100'                MAKE IT 21ST CENTURY        00095300
*                                                                       00095400
GETDATE1 EQU   *                                                        00095500
*                                                                       00095600
         ZAP   SYEAR,YEAR                   GET THE YEAR                00095700
         DP    SYEAR,=P'+400'               DIVIDE YEAR BY 400          00095800
*                                                                       00095900
         CP    SYEAR+2(2),=P'+0'            REMAINDER ZERO?             00096000
         BE    GETDATE2                     YES, IT'S  A LEAP YEAR      00096100
*                                                                       00096200
         ZAP   SYEAR,YEAR                   GET THE YEAR                00096300
         DP    SYEAR,=P'+4'                 DIVIDE YEAR BY 4            00096400
*                                                                       00096500
         CP    SYEAR+3(1),=P'+0'            REMAINDER ZERO?             00096600
         BNE   GETDATE3                     NO, IT'S NOT A LEAP YEAR    00096700
*                                                                       00096800
         ZAP   SYEAR,YEAR                   GET THE YEAR                00096900
         DP    SYEAR,=P'+100'               DIVIDE YEAR BY 100          00097000
*                                                                       00097100
         CP    SYEAR+2(2),=P'+0'            REMAINDER ZERO?             00097200
         BE    GETDATE3                     YES, ITS NOT A LEAP YEAR    00097300
*                                                                       00097400
GETDATE2 EQU   *                                                        00097500
*                                                                       00097600
         AP    DATETABL+08(2),=P'+1'        UPDATE DAYS FOR LEAP YEAR   00097700
         AP    DATETABL+10(2),=P'+1'                  "                 00097800
         AP    DATETABL+14(2),=P'+1'                  "                 00097900
         AP    DATETABL+16(2),=P'+1'                  "                 00098000
         AP    DATETABL+20(2),=P'+1'                  "                 00098100
         AP    DATETABL+22(2),=P'+1'                  "                 00098200
         AP    DATETABL+26(2),=P'+1'                  "                 00098300
         AP    DATETABL+28(2),=P'+1'                  "                 00098400
         AP    DATETABL+32(2),=P'+1'                  "                 00098500
         AP    DATETABL+34(2),=P'+1'                  "                 00098600
         AP    DATETABL+38(2),=P'+1'                  "                 00098700
         AP    DATETABL+40(2),=P'+1'                  "                 00098800
         AP    DATETABL+44(2),=P'+1'                  "                 00098900
         AP    DATETABL+46(2),=P'+1'                  "                 00099000
         AP    DATETABL+50(2),=P'+1'                  "                 00099100
         AP    DATETABL+52(2),=P'+1'                  "                 00099200
         AP    DATETABL+56(2),=P'+1'                  "                 00099300
         AP    DATETABL+58(2),=P'+1'                  "                 00099400
         AP    DATETABL+62(2),=P'+1'                  "                 00099500
         AP    DATETABL+64(2),=P'+1'                  "                 00099600
         AP    DATETABL+68(2),=P'+1'                  "                 00099700
         AP    DATETABL+70(2),=P'+1'                  "                 00099800
*                                                                       00099900
GETDATE3 EQU   *                                                        00100000
*                                                                       00100100
         LA    R2,DATETABL                  GET ADDRESS OF DATE TABLE   00100200
*                                                                       00100300
GETDATE4 EQU   *                                                        00100400
*                                                                       00100500
         CP    DAYS,2(2,R2)                 COMPARE DAYS TO TABLE       00100600
         BH    GETDATE5                     IF HIGHER CONTINUE          00100700
*                                                                       00100800
         SP    DAYS,4(2,R2)                 GET THE DAY                 00100900
         ZAP   DBLEWORD,DAYS                GET DAY                     00101000
         CVB   R1,DBLEWORD                  CONVERT TO BINARY           00101100
         STC   R1,SDTMDAY                   PUT IN CORRELATOR           00101200
*                                                                       00101300
         ZAP   MONTH,0(2,R2)                GET THE MONTH               00101400
         ZAP   DBLEWORD,MONTH               GET MONTH                   00101500
         CVB   R1,DBLEWORD                  CONVERT TO BINARY           00101600
         STC   R1,SDTMMON                   PUT IN CORRELATOR           00101700
*                                                                       00101800
         ZAP   DBLEWORD,YEAR                GET YEAR                    00101900
         CVB   R1,DBLEWORD                  CONVERT TO BINARY           00102000
         STH   R1,HALFWORD                  PUT IN HALFWORD             00102100
         MVC   SDTMYEAR,HALFWORD            PUT IN CORRELATOR           00102200
*                                                                       00102300
         B     GETDATEX                     CONTINUE                    00102400
*                                                                       00102500
GETDATE5 EQU   *                                                        00102600
*                                                                       00102700
         LA    R2,6(R2)                     INCREMENT TO NEXT ENTRY     00102800
         B     GETDATE4                     CONTINUE                    00102900
*                                                                       00103000
GETDATEX EQU   *                                                        00103100
         L     R14,RGETDATE                                             00103200
         BR    R14                                                      00103300
         EJECT                                                          00103400
*********************************************************************** 00103500
*********************************************************************** 00103600
***                                                                 *** 00103700
*** This is the VTAM LU 6.2 ATTention exit.  It gets driven when    *** 00103800
*** a FMH5 is received and it receives the FMH5.                    *** 00103900
***                                                                 *** 00104000
*********************************************************************** 00104100
*********************************************************************** 00104200
ATTN     EQU   *                                                        00104300
         USING *,R15                                                    00104400
         LM    R10,R12,BASEADDR                                         00104500
         DROP  R15                                                      00104600
         USING TSO2NETV,R10,R11,R12                                     00104700
         ST    R14,RETADDR2                                             00104800
         LA    R13,SAVE2                                                00104900
*                                                                       00105000
         CLC   12(4,R1),=C'FMH5'            DID I RECEIVE A FMH5?       00105100
         BNE   ATTNX                        NO, EXIT                    00105200
*                                                                       00105300
         L     R2,0(R1)                     GET ACB ADDRESS             00105400
*                                                                       00105500
         APPCCMD CONTROL=RCVFMH5,                                      *00105600
               RPL=RPL3,                                               *00105700
               OPTCD=ASY,                                              *00105800
               EXIT=EXITRPL,                                           *00105900
               CONMODE=LLCA,                                           *00106000
               AREA=FMH5AREA,                                          *00106100
               AREALEN=255                                              00106200
*                                                                       00106300
         LTR   R15,R15           GENERAL RETURN CODE OKAY?              00106400
         BNZ   ATTN1             NO, DISPLAY ERROR MESSAGE              00106500
*                                                                       00106600
         LTR   R0,R0             CONDITIONAL COMPLETION OKAY?           00106700
         BZ    ATTNX             YES, EXIT                              00106800
*                                                                       00106900
ATTN1    EQU   *                                                        00107000
*                                                                       00107100
         LA    R8,RPL3X          GET ADDRESS OF RPL EXTENSION           00107200
         LA    R9,RPL3           GET ADDRESS OF RPL                     00107300
*                                                                       00107400
         MVC   CONTROL,=CL8'RECVFMH5'                                   00107500
         MVC   QUALIFY,=CL8' '                                          00107600
         BAL   R14,LU62ERR       GO DISPLAY THE ERROR                   00107700
*                                                                       00107800
ATTNX    EQU   *                                                        00107900
         L     R14,RETADDR2                                             00108000
         BR    R14                                                      00108100
         EJECT                                                          00108200
*********************************************************************** 00108300
*********************************************************************** 00108400
***                                                                 *** 00108500
*** This is the VTAM LU 6.2 LOGON exit.  It gets driven when a SNA  *** 00108600
*** CINIT (Control Initiation) request is received.                 *** 00108700
***                                                                 *** 00108800
*** A APPCCMD CONTROL=OPRCNTL,QUALIFY=ACTSESS macro is issued to    *** 00108900
*** accept the CINIT and establish a LU 6.2 conversation.           *** 00109000
***                                                                 *** 00109100
*********************************************************************** 00109200
*********************************************************************** 00109300
LOGON    EQU   *                                                        00109400
         USING *,R15                                                    00109500
         LM    R10,R12,BASEADDR                                         00109600
         DROP  R15                                                      00109700
         USING TSO2NETV,R10,R11,R12                                     00109800
         ST    R14,RETADDR4                 SAVE RETURN ADDRESS         00109900
         LA    R13,SAVE4                    GET ADDRESS OF SAVEAREA     00110000
*                                                                       00110100
         L     R2,0(R1)                     GET ACB ADDRESS             00110200
         L     R3,20(R1)                    GET CID                     00110300
         ST    R3,SCID                      SAVE CID                    00110400
*                                                                       00110500
         APPCCMD CONTROL=OPRCNTL,                                      *00110600
               QUALIFY=ACTSESS,                                        *00110700
               OPTCD=ASY,                                              *00110800
               EXIT=EXITRPL,                                           *00110900
               ACB=(2),                                                *00111000
               ARG=(3),                                                *00111100
               RPL=RPL4,                                               *00111200
               AREA=0                                                   00111300
*                                                                       00111400
LOGONX   EQU   *                                                        00111500
         L     R14,RETADDR4                 RESTORE RETURN ADDRESS      00111600
         BR    R14                          RETURN                      00111700
         EJECT                                                          00111800
*********************************************************************** 00111900
*********************************************************************** 00112000
***                                                                 *** 00112100
*** This is the VTAM LU 6.2 LOGON exit.  It gets driven when a SNA  *** 00112200
*** BIND request is received.                                       *** 00112300
***                                                                 *** 00112400
*** A APPCCMD CONTROL=OPRCNTL,QUALIFY=ACTSESS macro is issued to    *** 00112500
*** accept the BIND.                                                *** 00112600
***                                                                 *** 00112700
*********************************************************************** 00112800
*********************************************************************** 00112900
SCIP     EQU   *                                                        00113000
         USING *,R15                                                    00113100
         LM    R10,R12,BASEADDR                                         00113200
         DROP  R15                                                      00113300
         USING TSO2NETV,R10,R11,R12                                     00113400
         ST    R14,RETADDR5                                             00113500
         LA    R13,SAVE5                                                00113600
*                                                                       00113700
         L     R2,0(R1)                     GET ACB ADDRESS             00113800
         L     R3,4(R1)                     GET CID                     00113900
         ST    R3,RCID                      SAVE CID                    00114000
         L     R9,16(R1)                    GET RPL ADDRESS             00114100
*                                                                       00114200
         TM    RPLCNTDC,RPLTBIND            DRIVEN FOR A BIND?          00114300
         BNO   SCIPX                        NO, EXIT                    00114400
*                                                                       00114500
         TM    RPLCHN,RPLVACS               LU 6.2 BIND?                00114600
         BNO   SCIPX                        NO, EXIT                    00114700
*                                                                       00114800
         APPCCMD CONTROL=OPRCNTL,                                      *00114900
               QUALIFY=ACTSESS,                                        *00115000
               OPTCD=ASY,                                              *00115100
               EXIT=EXITRPL,                                           *00115200
               RPL=RPL5,                                               *00115300
               ACB=(2),                                                *00115400
               ARG=(3),                                                *00115500
               AREA=0                                                   00115600
*                                                                       00115700
SCIPX    EQU   *                                                        00115800
         L     R14,RETADDR5                                             00115900
         BR    R14                                                      00116000
         EJECT                                                          00116100
*********************************************************************** 00116200
*********************************************************************** 00116300
***                                                                 *** 00116400
*** This is the VTAM RPL exit.  It gets driven when asynchronous    *** 00116500
*** VTAM requests are posted.                                       *** 00116600
***                                                                 *** 00116700
*** A APPCCMD CONTROL=CHECK macro is issued to process the request. *** 00116800
***                                                                 *** 00116900
*********************************************************************** 00117000
*********************************************************************** 00117100
EXITRPL  EQU   *                                                        00117200
         USING *,R15                                                    00117300
         LM    R10,R12,BASEADDR                                         00117400
         DROP  R15                                                      00117500
         USING TSO2NETV,R10,R11,R12                                     00117600
         ST    R14,RETADDR3                                             00117700
         LA    R13,SAVE3                                                00117800
*                                                                       00117900
         APPCCMD CONTROL=CHECK,RPL=(1)                                  00118000
*                                                                       00118100
         LTR   R15,R15           GENERAL RETURN CODE OKAY?              00118200
         BNZ   EXITRPL1          NO, DISPLAY ERROR MESSAGE              00118300
         LTR   R0,R0             CONDITIONAL COMPLETION OKAY?           00118400
         BZ    EXITRPLX          YES, EXIT                              00118500
*                                                                       00118600
EXITRPL1 EQU   *                                                        00118700
*                                                                       00118800
         LR    R9,R2             GET ADDRESS OF RPL                     00118900
         L     R8,RPLAAREA       GET ADDRESS OF RPL EXTENSION           00119000
*                                                                       00119100
         MVC   CONTROL,=CL8'CHECK'                                      00119200
         MVC   QUALIFY,=CL8' '                                          00119300
         BAL   R14,LU62ERR       GO DISPLAY THE ERROR                   00119400
*                                                                       00119500
EXITRPLX EQU   *                                                        00119600
         L     R14,RETADDR3                                             00119700
         BR    R14                                                      00119800
         EJECT                                                          00119900
*********************************************************************** 00120000
*********************************************************************** 00120100
***                                                                 *** 00120200
*** This routine syntax checks and extracts the command parameters. *** 00120300
*** The syntax of the command is:                                   *** 00120400
***                                                                 *** 00120500
*** TSO2NETV netview command-with-parameters                        *** 00120600
***                                                                 *** 00120700
*** The TSO user id is extracted from the TSO PSCB control block    *** 00120800
*** and is used as the VTAM application name and the requestor      *** 00120900
*** operator ID in the MDSMU.                                       *** 00121000
***                                                                 *** 00121100
*********************************************************************** 00121200
*********************************************************************** 00121300
GETPARM  EQU   *                                                        00121400
         ST    R14,RGETPARM            SAVE RETURN ADDRESS              00121500
*                                                                       00121600
         MVI   OKAY,C'Y'               INITIALIZE OKAY SWITCH           00121700
*                                                                       00121800
         L     R1,CPPL_ADDRESS         GET ADDRESS OF CPPL              00121900
*                                                                       00122000
         USING CPPL,R1                 R1 IS BASE FOR CPPL              00122100
*                                                                       00122200
         L     R2,CPPLCBUF             GET ADDRESS OF COMMAND BUFFER    00122300
         DROP  R1                                                       00122400
*                                                                       00122500
         LH    R3,0(R2)                GET LENGTH OF COMMAND BUFFER     00122600
         SH    R3,=H'4'                SUBTRACT LENGTH OF LENGTH + OFFS 00122700
         CH    R3,2(R2)                ANY PARM SPECIFIED?              00122800
         BNE   GETPARM1                YES, CONTINUE                    00122900
*                                                                       00123000
         MVC   MESSAGE(ERRMSG1L),ERRMSG1                                00123100
         BAL   R14,PUTLINE             DISPLAY ERROR MESSAGE            00123200
*                                                                       00123300
         MVI   OKAY,C'N'               INDICATE AN ERROR                00123400
*                                                                       00123500
         B     GETPARMX                EXIT                             00123600
*                                                                       00123700
GETPARM1 EQU   *                                                        00123800
*                                                                       00123900
         LA    R3,4(R2,R3)             GET END OF PARM                  00124000
         AH    R2,2(R2)                POINT TO TEXT                    00124100
         LA    R2,4(R2)                                                 00124200
*                                                                       00124300
         MVC   NETVIEW,=CL8' '         CLEAR NETVIEW LU NAME            00124400
*                                                                       00124500
         LA    R4,NETVIEW              GET ADDRESS OF NETVIEW LU NAME   00124600
         LA    R5,5                    MAXIMUM LENGTH IS 5 BYTES        00124700
*                                                                       00124800
GETPARM2 EQU   *                                                        00124900
*                                                                       00125000
         BAL   R14,CHEKDELM            CHECK FOR A BLANK OR COMMA       00125100
         BNE   GETPARM3                BRANCH IF NOT                    00125200
*                                                                       00125300
         LA    R2,1(R2)                INCREMENT TO NEXT BYTE           00125400
         CR    R2,R3                   ANY MORE PARM LEFT?              00125500
         BL    GETPARM2                YES, CONTINUE                    00125600
*                                                                       00125700
         B     GETPARM6                DISPLAY ERROR MESSAGE AND EXIT   00125800
*                                                                       00125900
GETPARM3 EQU   *                                                        00126000
*                                                                       00126100
         BAL   R14,CHEKDELM            CHECK FOR A BLANK OR COMMA       00126200
         BE    GETPARM4                BRANCH IF SO                     00126300
*                                                                       00126400
         MVC   0(1,R4),0(R2)           MOVE 1 BYTE OF NETVIEW LU NAME   00126500
         LA    R2,1(R2)                INCREMENT TO NEXT BYTE           00126600
         LA    R4,1(R4)                INCREMENT TO NEXT BYTE           00126700
*                                                                       00126800
         CR    R2,R3                   ANY MORE PARM LEFT?              00126900
         BNL   GETPARM7                NO, ERROR                        00127000
*                                                                       00127100
         BCT   R5,GETPARM3             KEEP GOING                       00127200
*                                                                       00127300
         BAL   R14,CHEKDELM            CHECK FOR A BLANK OR COMMA       00127400
         BNE   GETPARM6                IF NOT THEN ITS AN ERROR         00127500
*                                                                       00127600
GETPARM4 EQU   *                                                        00127700
*                                                                       00127800
         OC    NETVIEW,=8XL1'40'       MAKE NETVIEW LU NAME UPPERCASE   00127900
         MVC   DLUNAME,NETVIEW         GET DESTINATION LU NAME          00128000
*                                                                       00128100
         LA    R2,1(R2)                INCREMENT PAST DELIMITER         00128200
         SR    R3,R2                   GET LENGTH OF COMMAND            00128300
         LTR   R3,R3                   ANY COMMAND LEFT?                00128400
         BZ    GETPARM7                NO, ERROR                        00128500
*                                                                       00128600
         CH    R3,=H'240'              COMMAND > 240 BYTES?             00128700
         BNH   GETPARM5                NO, CONTINUE                     00128800
*                                                                       00128900
         LA    R3,240                  MAXIMUM IS 240 BYTES             00129000
*                                                                       00129100
GETPARM5 EQU   *                                                        00129200
*                                                                       00129300
         MVI   COMMAND,X'40'           INITIALIZE COMMAND               00129400
         MVC   COMMAND+1(L'COMMAND-1),COMMAND                           00129500
*                                                                       00129600
         LA    R4,COMMAND                                               00129700
         LR    R5,R3                                                    00129800
         MVCL  R4,R2                   MOVE COMMAND TO SEND BUFFER      00129900
*                                                                       00130000
         B     GETPARMX                EXIT                             00130100
*                                                                       00130200
GETPARM6 EQU   *                                                        00130300
*                                                                       00130400
         MVC   MESSAGE(ERRMSG2L),ERRMSG2                                00130500
         BAL   R14,PUTLINE             DISPLAY ERROR MESSAGE            00130600
*                                                                       00130700
         MVI   OKAY,C'N'               INDICATE AN ERROR                00130800
*                                                                       00130900
         B     GETPARMX                EXIT                             00131000
*                                                                       00131100
GETPARM7  EQU  *                                                        00131200
*                                                                       00131300
         MVC   MESSAGE(ERRMSG3L),ERRMSG3                                00131400
         BAL   R14,PUTLINE             DISPLAY ERROR MESSAGE            00131500
*                                                                       00131600
         MVI   OKAY,C'N'               INDICATE AN ERROR                00131700
*                                                                       00131800
GETPARMX EQU   *                                                        00131900
         L     R14,RGETPARM            RESTORE RETURN ADDRESS           00132000
         BR    R14                     RETURN                           00132100
         EJECT                                                          00132200
*********************************************************************** 00132300
*********************************************************************** 00132400
***                                                                 *** 00132500
*** This routine is called to check the byte pointed to by register *** 00132600
*** 2 to see if it is a delimiter (blank or comma).  The routine    *** 00132700
*** returns with the condition code set.                            *** 00132800
***                                                                 *** 00132900
*********************************************************************** 00133000
*********************************************************************** 00133100
CHEKDELM EQU   *                                                        00133200
         CLI   0(R2),X'40'             IS BYTE A BLANK?                 00133300
         BER   R14                     YES, EXIT WITH COND CODE         00133400
         CLI   0(R2),C','              IS BYTE A COMMA?                 00133500
         BR    R14                     EXIT UNCONDITIONAL               00133600
         EJECT                                                          00133700
*********************************************************************** 00133800
*********************************************************************** 00133900
***                                                                 *** 00134000
***  This routine initializes with VTAM.  A VTAM ACB is opened      *** 00134100
***  to connect this application with VTAM.  The ACB application    *** 00134200
***  name is the 7 byte TSO user id.  If the OPEN ACB is successful *** 00134300
***  the ACB resource ID vector list is searched to retrieve the    *** 00134400
***  network ID of the network where this application is running.   *** 00134500
***  The network ID is moved to the destination network ID and      *** 00134600
***  requestor network ID subfields in the MDSMU.                   *** 00134700
***                                                                 *** 00134800
***  Finally a VTAM SETLOGON macro is issued to tell VTAM that      *** 00134900
***  this application is ready to accept bind requests which will   *** 00135000
***  drive the VTAM logon exit.                                     *** 00135100
***                                                                 *** 00135200
*********************************************************************** 00135300
*********************************************************************** 00135400
INITRTN  EQU   *                                                        00135500
         ST    R14,RINITRTN      SAVE RETURN ADDRESS                    00135600
*                                                                       00135700
         MVI   OKAY,C'Y'         INDICATE EVERYTHING IS OKAY            00135800
*                                                                       00135900
         BAL   R14,OPEN_VTAMACB  GO OPEN THE VTAM ACB                   00136000
*                                                                       00136100
         CLI   OKAY,C'Y'         OKAY?                                  00136200
         BNE   INITRTNX          NO, EXIT                               00136300
*                                                                       00136400
         LA    R2,VTAMACB        GET ADDRESS OF ACB                     00136500
         USING IFGACB,R2         R2 IS BASE REGISTER                    00136600
*                                                                       00136700
         L     R3,ACBRIVL        GET ADDRESS OF RESOURCE ID VECTOR LIST 00136800
         DROP  R2                                                       00136900
         LR    R2,R3             GET ADDRESS OF RESOURCE ID VECTOR LIST 00137000
         MVC   HALFWORD,0(R2)    GET LENGTH OF VECTOR LIST              00137100
         AH    R3,HALFWORD       GET END ADDRESS OF VECTOR LIST         00137200
*                                                                       00137300
         LA    R2,2(R2)          INCREMENT PAST LENGTH                  00137400
*                                                                       00137500
INITRTN1 EQU   *                                                        00137600
*                                                                       00137700
         CR    R2,R3             ANY MORE VECTORS TO CHECK?             00137800
         BNL   INITRTN3          NO, ALL DONE EXIT                      00137900
*                                                                       00138000
         CLI   1(R2),X'06'       NETWORK NAME VECTOR?                   00138100
         BE    INITRTN2          YES, CONTINUE                          00138200
*                                                                       00138300
         SLR   R1,R1             CLEAR LENGTH REGISTER                  00138400
         IC    R1,0(R2)          GET LENGTH OF VECTOR                   00138500
         AR    R2,R1             INCREMENT TO NEXT VECTOR               00138600
         B     INITRTN1          KEEP CHECKING                          00138700
*                                                                       00138800
INITRTN2 EQU   *                                                        00138900
*                                                                       00139000
         SLR   R1,R1             CLEAR LENGTH REGISTER                  00139100
         IC    R1,0(R2)          GET LENGTH                             00139200
         SH    R1,=H'3'          MAKE LENGTH EXECUTEABLE                00139300
         EX    R1,GETNETID       GET THE NETWORK ID                     00139400
*                                                                       00139500
INITRTN3 EQU   *                                                        00139600
*                                                                       00139700
         SETLOGON RPL=RPL1,OPTCD=START ISSUE SETLOGON                   00139800
         LTR   R15,R15           SETLOGON OKAY?                         00139900
         BZ    INITRTN4          YES, CONTINUE                          00140000
*                                                                       00140100
         CLOSE VTAMACB           NO, CLOSE ACB                          00140200
*                                                                       00140300
         MVI   OKAY,C'N'         INDICATE A ERROR                       00140400
         MVC   MESSAGE(ERRMSG8L),ERRMSG8                                00140500
         BAL   R14,PUTLINE       DISPLAY ERROR MESSAGE                  00140600
*                                                                       00140700
         B     INITRTNX          EXIT                                   00140800
*                                                                       00140900
INITRTN4 EQU   *                                                        00141000
*                                                                       00141100
         MVC   OLUNETID,NETID    GET ORIGINATING NETWORK ID             00141200
         MVC   REQNETID,NETID    GET REQUESTING NETWORK ID              00141300
*                                                                       00141400
         MVC   OLUNAME,LUNAME    GET ORIGINATING LU NAME                00141500
         MVC   REQLUNAME,LUNAME  GET ORIGINATING LU NAME                00141600
*                                                                       00141700
INITRTNX EQU   *                                                        00141800
         L     R14,RINITRTN      RESTORE RETURN ADDRESS                 00141900
         BR    R14               RETURN                                 00142000
*                                                                       00142100
GETNETID MVC   NETID(0),2(R2)    MOVE NETID FROM VECTOR                 00142200
*                                                                       00142300
         EJECT                                                          00142400
OPEN_VTAMACB EQU *                                                      00142500
         ST    R14,ROPEN_VTAMACB SAVE RETURN ADDRESS                    00142600
*                                                                       00142700
         ZAP   DBLEWORD,=P'+1'   START WITH ACB TSO2NV01                00142800
*                                                                       00142900
OPEN_VTAMACB1 EQU *                                                     00143000
*                                                                       00143100
         CP    DBLEWORD,=P'+100' ANY MORE ACBS TO TRY?                  00143200
         BE    OPEN_VTAMACB2     NO, ERROR                              00143300
*                                                                       00143400
         UNPK  LUNUMBER,DBLEWORD+6(2)                                   00143500
         OI    LUNUMBER+1,X'F0'   FIX THE SIGN                          00143600
*                                                                       00143700
         MVC   LUNAME+6(2),LUNUMBER                                     00143800
*                                                                       00143900
         OPEN  VTAMACB           OPEN ACB                               00144000
*                                                                       00144100
         LTR   R15,R15           OPEN OKAY?                             00144200
         BZ    OPEN_VTAMACBX     YES, EXIT                              00144300
*                                                                       00144400
         AP    DBLEWORD,=P'+1'   INCRMENT TO NEXT ACB NUMBER            00144500
*                                                                       00144600
         B     OPEN_VTAMACB1     TRY AGAIN                              00144700
*                                                                       00144800
OPEN_VTAMACB2 EQU *                                                     00144900
*                                                                       00145000
         MVI   OKAY,C'N'         INDICATE AN OPEN ERROR                 00145100
*                                                                       00145200
         MVC   MESSAGE(ERRMSG4L),ERRMSG4                                00145300
         BAL   R14,PUTLINE       DISPLAY ERROR MESSAGE                  00145400
*                                                                       00145500
OPEN_VTAMACBX EQU *                                                     00145600
         L     R14,ROPEN_VTAMACB RESTORE RETURN ADDRESS                 00145700
         BR    R14               RETURN                                 00145800
         EJECT                                                          00145900
*********************************************************************** 00146000
*********************************************************************** 00146100
***                                                                 *** 00146200
*** This routine gets called for APPCCMD macro errors.  A message   *** 00146300
*** is displayed which contains the values of:                      *** 00146400
***                                                                 *** 00146500
***   Register 15                                                   *** 00146600
***   Register 0                                                    *** 00146700
***   RCPRI                                                         *** 00146800
***   RCSEC                                                         *** 00146900
***                                                                 *** 00147000
*********************************************************************** 00147100
*********************************************************************** 00147200
LU62ERR  EQU   *                                                        00147300
         ST    R14,RLU62ERR                                             00147400
*                                                                       00147500
         MVI   OKAY,C'N'                                                00147600
*                                                                       00147700
         STM   R15,R0,RETCODES                                          00147800
         LA    R1,RETCODES                                              00147900
         LA    R2,R15VALUE                                              00148000
         LA    R3,4                                                     00148100
*                                                                       00148200
         BAL   R14,HEXCONV                                              00148300
         LA    R1,RETCODES+4                                            00148400
         LA    R2,R0VALUE                                               00148500
         LA    R3,4                                                     00148600
         BAL   R14,HEXCONV                                              00148700
*                                                                       00148800
         LA    R1,RPL6RCPR                                              00148900
         LA    R2,RCPRI                                                 00149000
         LA    R3,2                                                     00149100
         BAL   R14,HEXCONV                                              00149200
*                                                                       00149300
         LA    R1,RPL6RCSC                                              00149400
         LA    R2,RCSEC                                                 00149500
         LA    R3,2                                                     00149600
         BAL   R14,HEXCONV                                              00149700
*                                                                       00149800
         MVC   MESSAGE(ERRMSG5L),ERRMSG5                                00149900
         BAL   R14,PUTLINE       DISPLAY ERROR MESSAGE                  00150000
*                                                                       00150100
         LM    R15,R0,RETCODES                                          00150200
*                                                                       00150300
LU62ERRX EQU   *                                                        00150400
         L     R14,RLU62ERR                                             00150500
         BR    R14                                                      00150600
         EJECT                                                          00150700
PUTLINE  EQU   *                                                        00150800
         ST    R14,RPUTLINE                                             00150900
*                                                                       00151000
         L     R1,CPPL_ADDRESS         GET ADDRESS OF CPPL              00151100
         USING CPPL,R1                 R1 IS BASE FOR CPPL              00151200
         L     R6,CPPLUPT              GET UPT ADDRESS                  00151300
         L     R7,CPPLECT              GET ECT ADDRESS                  00151400
         DROP  R1                                                       00151500
*                                                                       00151600
         PUTLINE PARM=PLBLOCK,                                         *00151700
               UPT=(6),                                                *00151800
               ECT=(7),                                                *00151900
               ECB=PUTLECB,                                            *00152000
               OUTPUT=(MESSAGE,TERM,SINGLE,DATA),                      *00152100
               MF=(E,IOPLADS)                                           00152200
*                                                                       00152300
PUTLINEX EQU   *                                                        00152400
         L     R14,RPUTLINE                                             00152500
         BR    R14                                                      00152600
         EJECT                                                          00152700
*********************************************************************** 00152800
*********************************************************************** 00152900
***                                                                 *** 00153000
*** This routine gets called to convert a variable length string    *** 00153100
*** of hexadecimal bytes to a printable hexadecmial equivalent.     *** 00153200
***                                                                 *** 00153300
***     On input:  R1 = address of input field                      *** 00153400
***                R2 = address of output field                     *** 00153500
***                R3 has length of input field                     *** 00153600
***                                                                 *** 00153700
*********************************************************************** 00153800
*********************************************************************** 00153900
HEXCONV  EQU   *                                                        00154000
         ST    R14,RHEXCONV            SAVE RETURN ADDRESS              00154100
HEXCONV1 EQU   *                                                        00154200
         SLR   R4,R4                   CLEAR R4                         00154300
         IC    R4,0(R1)                GET BYTE                         00154400
         SRL   R4,4                    SHIFT OVER 4 BITS                00154500
         O     R4,=X'000000F0'         OR IN SIGN                       00154600
         C     R4,=X'000000F9'         GREATER THAN 9?                  00154700
         BNH   HEXCONV2                NO, CONTINUE                     00154800
         S     R4,=F'249'              YES, SUBTRACT 9                  00154900
         O     R4,=X'000000C0'         MAKE IT PRINTABLE                00155000
HEXCONV2 EQU   *                                                        00155100
         STC   R4,0(R2)                STORE CHARACTER                  00155200
         LA    R2,1(R2)                INCREMENT TO NEXT OUTPUT BYTE    00155300
         SLR   R4,R4                   CLEAR R4                         00155400
         IC    R4,0(R1)                GET BYTE                         00155500
         N     R4,=X'0000000F'         CLEAR ALL BUT LAST 4 BITS        00155600
         O     R4,=X'000000F0'         OR IN SIGN                       00155700
         C     R4,=X'000000F9'         GREATER THAN 9?                  00155800
         BNH   HEXCONV3                NO, CONTINUE                     00155900
         S     R4,=F'249'              YES, SUBTRACT 9                  00156000
         O     R4,=X'000000C0'         MAKE IT PRINTABLE                00156100
HEXCONV3 EQU   *                                                        00156200
         STC   R4,0(R2)                STORE CHARACTER                  00156300
         LA    R2,1(R2)                INCREMENT TO NEXT OUTPUT BYTE    00156400
         LA    R1,1(R1)                INCREMENT TO NEXT INPUT BYTE     00156500
         BCT   R3,HEXCONV1             PROCESS NEXT BYTE                00156600
HEXCONVX EQU   *                                                        00156700
         L     R14,RHEXCONV            RESTORE RETURN ADDRESS           00156800
         BR    R14                     RETURN                           00156900
         EJECT                                                          00157000
*********************************************************************** 00157100
*********************************************************************** 00157200
***                                                                 *** 00157300
*** This routine is the STIMER exit routine.  It gets driven when   *** 00157400
*** the time interval expires.  It posts an ECB which is waited     *** 00157500
*** on in the mainline routine.                                     *** 00157600
***                                                                 *** 00157700
*********************************************************************** 00157800
*********************************************************************** 00157900
STIMERX  EQU   *                                                        00158000
         USING *,R15                   R15 IS TEMPORARY BASE REGISTER   00158100
         STM   R14,R12,12(R13)         SAVE CALLING PROGRAMS REGISTERS  00158200
         LM    R10,R12,BASEADDR        GET BASE REGISTER ADDRESSES      00158300
         DROP  R15                     DROP TEMPORARY BASE REGISTER     00158400
         USING TSO2NETV,R10,R11,R12    RESET BASE REGISTERS             00158500
         ST    R13,SAVE6+4             SAVE CALLERS SAVEAREA ADDR       00158600
         LR    R2,R13                  GET ADDRESS OF CALLERS SAVEAREA  00158700
         LA    R13,SAVE6               R13 HAS MY SAVEAREA ADDRESS      00158800
         ST    R13,8(R2)               STORE MINE IN CALLERS            00158900
*                                                                       00159000
         POST  TIMEECB                 POST TIMER ECB FOR MAINLINE      00159100
*                                                                       00159200
         L     R13,SAVE6+4             RESTORE CALLERS SAVEAREA ADDRESS 00159300
         LM    R14,R12,12(R13)         RESTORE CALLERS REGISTERS        00159400
         SR    R15,R15                 SET RETURN CODE TO 0             00159500
         BR    R14                     RETURN                           00159600
         EJECT                                                          00159700
*                                                                       00159800
         LTORG                                                          00159900
*                                                                       00160000
BASEADDR DS    3F                                                       00160100
*                                                                       00160200
         EJECT                                                          00160300
*                                                                       00160400
DBLEWORD DS    D                                                        00160500
SAVEAREA DS    18F                                                      00160600
SAVE2    DS    18F                                                      00160700
SAVE3    DS    18F                                                      00160800
SAVE4    DS    18F                                                      00160900
SAVE5    DS    18F                                                      00161000
SAVE6    DS    18F                                                      00161100
CPPL_ADDRESS   DS F                                                     00161200
BUFFADDR DS    F                                                        00161300
BUFFSIZE DS    F                                                        00161400
BUFFEND  DS    F                                                        00161500
IOPLADS  DC    4F'0'                                                    00161600
PUTLECB  DC    F'0'                                                     00161700
PLBLOCK  PUTLINE MF=L                                                   00161800
SAVER2R3 DS    F                                                        00161900
RETADDR2 DS    F                                                        00162000
RETADDR3 DS    F                                                        00162100
RETADDR4 DS    F                                                        00162200
RETADDR5 DS    F                                                        00162300
RETCODES DS    2F                                                       00162400
SAVEADDR DS    F                                                        00162500
RINITRTN DS    F                                                        00162600
RPUTLINE DS    F                                                        00162700
RGETPARM DS    F                                                        00162800
ROPEN_VTAMACB DS F                                                      00162900
RGETDATE DS    F                                                        00163000
RRECEIVE DS    F                                                        00163100
RMAINRTN DS    F                                                        00163200
RSENDCON DS    F                                                        00163300
RALLOC   DS    F                                                        00163400
RGETDNET DS    F                                                        00163500
RSEND    DS    F                                                        00163600
RPARSE   DS    F                                                        00163700
RCHKRECV DS    F                                                        00163800
RLU62ERR DS    F                                                        00163900
RP1212MV DS    F                                                        00164000
RP1532MV DS    F                                                        00164100
RHEXCONV DS    F                                                        00164200
WAITTIME DC    F'1500'                              15 SECONDS          00164300
ECBLIST  DC    A(RECVECB),AL1(128),AL3(TIMEECB)                         00164400
RECVECB  DS    F                                                        00164500
TIMEECB  DS    F                                                        00164600
SCONVID  DS    F                                                        00164700
SCID     DS    F                                                        00164800
RCID     DS    F                                                        00164900
*                                                                       00165000
SENSE    DS    F                                                        00165100
*                                                                       00165200
OKAY     DS    C                                                        00165300
HALFWORD DS    H                                                        00165400
*                                                                       00165500
TIME     DS    F                                                        00165600
TIMESIGN DC    X'0C'                                                    00165700
UNPKTIME DS    CL9                                                      00165800
*                                                                       00165900
DATE     DS    F                                                        00166000
*                                                                       00166100
YEAR     DS    PL3                                                      00166200
DAYS     DS    PL2                                                      00166300
MONTH    DS    PL2                                                      00166400
SYEAR    DS    PL4                                                      00166500
*                                                                       00166600
SLDAREA  DC    64XL1'00'                                                00166700
SLDLENG  EQU   *-SLDAREA                                                00166800
*                                                                       00166900
CNOSAREA DS    XL7                                                      00167000
*                                                                       00167100
FMH5     DC    AL1(FMH5LEN)     FMH LENGTH                              00167200
         DC    X'05'            FMH TYPE                                00167300
         DC    X'02FF'          ATTACH CODE                             00167400
         DC    X'00'            PIP NOT PRESENT                         00167500
         DC    X'03'            PARM LENGTH                             00167600
         DC    X'D0'            CONVERSATION TYPE                       00167700
         DC    X'00'            RESERVED                                00167800
         DC    X'40'            SYNC LEVEL (CONFIRM)                    00167900
         DC    X'04'            TRANSACTION PROGRAM NAME LENGTH         00168000
         DC    X'23F0F0F2'      TRANSACTION PROGRAM NAME                00168100
         DC    X'00'            NO ACCESS SECURITY INFORMATION          00168200
         DC    X'00'            NO LOGICAL UNIT OF WORK IDENTIFIER      00168300
         DC    X'00'            NO SENDER CONVERSATION CORRELATOR       00168400
FMH5LEN  EQU   *-FMH5                                                   00168500
*                                                                       00168600
FMH5AREA DS    XL255                                                    00168700
*                                                                       00168800
VTAMAPPL DS    0CL9                                                     00168900
         DC    X'08'                                                    00169000
LUNAME   DC    CL8'TSO2NVXX'                                            00169100
*                                                                       00169200
LUNUMBER DS    CL2                                                      00169300
*                                                                       00169400
NETVIEW  DC    CL8' '                                                   00169500
*                                                                       00169600
NETID    DC    CL8' '                                                   00169700
         EJECT                                                          00169800
DATETABL DC    PL2'01',PL2'031',PL2'000'    JANUARY                     00169900
         DC    PL2'02',PL2'059',PL2'031'    FEBRUARY                    00170000
         DC    PL2'03',PL2'090',PL2'059'    MARCH                       00170100
         DC    PL2'04',PL2'120',PL2'090'    APRIL                       00170200
         DC    PL2'05',PL2'151',PL2'120'    MAY                         00170300
         DC    PL2'06',PL2'181',PL2'151'    JUNE                        00170400
         DC    PL2'07',PL2'212',PL2'181'    JULY                        00170500
         DC    PL2'08',PL2'243',PL2'212'    AUGUST                      00170600
         DC    PL2'09',PL2'273',PL2'243'    SEPTEMBER                   00170700
         DC    PL2'10',PL2'304',PL2'273'    OCTOBER                     00170800
         DC    PL2'11',PL2'334',PL2'304'    NOVEMBER                    00170900
         DC    PL2'12',PL2'365',PL2'334'    DECEMBER                    00171000
         EJECT                                                          00171100
**********************************************************************  00171200
*        MDS-MU Major Vector x'1310'                                 *  00171300
**********************************************************************  00171400
         DS    0H                                                       00171500
MDSMU    DC    AL2(MDSMUL)          Major Vector length                 00171600
GDS1310  DC    X'1310'              Major Vector key                    00171700
*                                                                       00171710
**********************************************************************  00171800
*        MDS Routing Information GDS Variable x'1311'                *  00171900
**********************************************************************  00172000
GDS1311  DC    AL2(GDS1311L)        GDS Variable length                 00172100
         DC    X'1311'              GDS Variable key                    00172200
*--------------------------------------------------------------------*  00172300
*        Origin Location Name Subvector x'81'                        *  00172400
*--------------------------------------------------------------------*  00172500
SV81     DC    AL1(SV81L)           Subvector length                    00172600
SV81KEY  DC    X'81'                Subvector key                       00172700
*--------------------------------------------------------------------*  00172800
*        Origin Location Name Network ID Subfield x'01'              *  00172900
*--------------------------------------------------------------------*  00173000
SV81F01  DC    AL1(SV81F01L)        Subfield length                     00173100
         DC    X'01'                Subfield Key                        00173200
OLUNETID DC    CL8' '               Origin Network ID                   00173300
SV81F01L EQU   *-SV81F01            End of subfield x'01'               00173400
*--------------------------------------------------------------------*  00173500
*        Origin Location Name LU Name Subfield x'02'                 *  00173510
*--------------------------------------------------------------------*  00173700
SV81F02  DC    AL1(SV81F02L)        Subvector length                    00173800
         DC    X'02'                Subvector key                       00173900
OLUNAME  DC    CL8' '               Origin LU Name                      00174000
SV81F02L EQU   *-SV81F02            End of Subfield x'02'               00174100
*--------------------------------------------------------------------*  00174200
*        Origin Location Name Application program Subfield x'03'     *  00174300
*--------------------------------------------------------------------*  00174400
SV81F03  DC    AL1(SV81F03L)        Subfield length                     00174500
         DC    X'03'                Subfield key                        00174600
OLUAPPL  DC    CL8'TSO2NETV'        Origin Application program name     00174700
SV81F03L EQU   *-SV81F03            End of Subfield x'03'               00174800
SV81L    EQU   *-SV81               End of Subvector x'81'              00174900
*--------------------------------------------------------------------*  00175000
*        Destination Location Name Subvector x'82'                   *  00175010
*--------------------------------------------------------------------*  00175200
SV82     DC    AL1(SV82L)           Subvector length                    00175300
SV82KEY  DC    X'82'                Subvector key                       00175400
*--------------------------------------------------------------------*  00175500
*        Destination Location Name Network ID Subfield x'01'         *  00175510
*--------------------------------------------------------------------*  00175700
SV82F01  DC    AL1(SV82F01L)        Subfield length                     00175800
         DC    X'01'                Subfield key                        00175900
DLUNETID DC    CL8' '               Destination Network ID              00176000
SV82F01L EQU   *-SV82F01            End of Subvector x'01'              00176100
*--------------------------------------------------------------------*  00176200
*        Destination Location Name LU Name Subfield x'02'            *  00176210
*--------------------------------------------------------------------*  00176400
SV82F02  DC    AL1(SV82F02L)        Subfield length                     00176500
         DC    X'02'                Subfield key                        00176600
DLUNAME  DC    CL8' '               Destination LU Name                 00176700
SV82F02L EQU   *-SV82F02            End of Subvector x'02'              00176710
*--------------------------------------------------------------------*  00176900
*        Destination Location Name Application program Subfield x'03' * 00176910
*--------------------------------------------------------------------*  00177100
SV82F03  DC    AL1(SV82F03L)        Subfield length                     00177200
         DC    X'03'                Subfield Key                        00177300
DLUAPPL  DC    CL8'NETV2TSO'        Destination Application Program     00177400
SV82F03L EQU   *-SV82F03            End of Subfield x'03'               00177500
SV82L    EQU   *-SV82               End of Subvector x'82'              00177600
*--------------------------------------------------------------------*  00177700
*        Flags Subvector x'90                                        *  00177800
*--------------------------------------------------------------------*  00177900
SV90     DC    AL1(SV90L)           Subvector length                    00178000
         DC    X'90'                Subvector key                       00178100
         DC    X'00'                Flags Byte 1                        00178200
*                                    MDS Message Type                   00178300
*                                     X'00' MDS Request                 00178400
*                                     X'01' MDS Reply                   00178500
*                                     X'02' MDS Error Message           00178600
         DC    X'C0'                Flags Byte 2                        00178700
*                                    MDS Message Chaining Flag          00178800
*                                     B'1... ....' First Message        00178900
*                                     B'0... ....' Not First Message    00179000
*                                     B'.1.. ....' Last Message         00179100
*                                     B'.0.. ....' Not Last Message     00179200
         DC    X'00'                Reserved                            00179300
SV90L    EQU   *-SV90               End of Subector x'90'               00179400
GDS1311L EQU   *-GDS1311            End of GDS Variable x'1311'         00179500
*                                                                       00179600
**********************************************************************  00179700
*        Agent Unit of Work GDS Variable  x'1549'                    *  00179800
**********************************************************************  00179900
GDS1549  DC    AL2(GDS1549L)        GDS Variable length                 00180000
         DC    X'1549'              GDS Variable key                    00180100
*--------------------------------------------------------------------*  00180200
*        Requester Location Name Subvector x'01'                     *  00180300
*--------------------------------------------------------------------*  00180400
SV01     DC    AL1(SV01L)           Subvector length                    00180500
         DC    X'01'                Subvector key                       00180600
*--------------------------------------------------------------------*  00180700
*        Requester Location Name Network ID Subfield x'01'           *  00180800
*--------------------------------------------------------------------*  00180900
SF01     DC    AL1(SF01L)           Subfield length                     00181000
         DC    X'01'                Subfield key                        00181100
REQNETID DC    CL8' '               Request Network ID                  00181200
SF01L    EQU   *-SF01               End of Subfield x'01'               00181300
*--------------------------------------------------------------------*  00181400
*        Requester Location Name LU Name Subfield x'02'              *  00181410
*--------------------------------------------------------------------*  00181600
SF02     DC    AL1(SF02L)           Subfield length                     00181700
         DC    X'02'                Subfield key                        00181800
REQLUNAME DC    CL8' '              Requester LU Name                   00181900
SF02L    EQU   *-SF02               End of Subfield x'02'               00182000
SV01L    EQU   *-SV01               End of Subvector x'01R              00182100
*--------------------------------------------------------------------*  00182200
*        Requester Agent Subvector x'04'                             *  00182300
*--------------------------------------------------------------------*  00182400
SV04     DC    AL1(SV04L)           Subvector Length                    00182500
         DC    X'04'                Subvector key                       00182600
REQAGENT DC    CL8'TSO2NETV'        Requester Application Program       00182700
SV04L    EQU   *-SV04               End of Subvector x'04'              00182800
*--------------------------------------------------------------------*  00182900
*        Sequence Number Date and Time Subvector x'02'               *  00183000
*--------------------------------------------------------------------*  00183100
SDTM     DC    AL1(SDTML)           Subvector length                    00183200
         DC    X'02'                Subvector key                       00183300
SDTMSEQ  DC    X'00000001'          Sequence number                     00183400
SDTMYEAR DC    AL2(0000)            Year                                00183500
SDTMMON  DC    AL1(00)              Month                               00183600
SDTMDAY  DC    AL1(00)              Day                                 00183700
SDTMHOUR DC    AL1(00)              Hour                                00183800
SDTMMIN  DC    AL1(00)              Minute                              00183900
SDTMSEC  DC    AL1(00)              Second                              00184000
SDTMHSEC DC    AL1(00)              Hundredth of second                 00184100
SDTMGMT  DC    X'E9'                GMT offset                          00184200
SDTML    EQU   *-SDTM               End Of Subvector x'02'              00184300
GDS1549L EQU   *-GDS1549            End of GDS Variable x'1549'         00184400
**********************************************************************  00184500
*                                                                       00184510
**********************************************************************  00184600
*        Control Point Management Services Unit  x'1212'             *  00184800
**********************************************************************  00184900
GDS1212  DC    AL2(GDS1212L)        CP_MSU length                       00185000
         DC    XL2'1212'            CP_MSU key                          00185100
*                                                                       00185110
**********************************************************************  00185120
*        Execute Command Major Vector x'8061'                        *  00185130
**********************************************************************  00185140
GDS8061  DC    AL2(GDS8061L)        Major Vector length                 00185200
         DC    XL2'8061'            Major Vector key                    00185300
*--------------------------------------------------------------------*  00185400
*        Name List Subvector  x'06'                                  *  00185500
*--------------------------------------------------------------------*  00185600
SV06     DC    AL1(SV06L)           Subvector length                    00185700
         DC    X'06'                Subvector key                       00185800
*--------------------------------------------------------------------*  00185810
*        Destination Application Name Subfield x'50'                 *  00185820
*--------------------------------------------------------------------*  00185830
SF50     DC    AL1(SF50L)           Subfield length                     00185900
         DC    X'50'                Subfield key                        00186000
         DC    CL8'NETV2TSO'        Destination Application Program     00186100
SF50L    EQU   *-SF50               End of Subfield x'50'               00186200
SV06L    EQU   *-SV06               End of Subvector x'06'              00186300
*--------------------------------------------------------------------*  00186310
*        Self Defining Text Message Subvector                        *  00186320
*--------------------------------------------------------------------*  00186330
SV31     DC    AL1(SV31L)           Subvector length                    00186500
         DC    X'31'                Subvector key                       00186600
COMMAND  DS    CL240                Command text                        00186700
SV31L    EQU   *-SV31               End of Subvector x'31'              00186800
*--------------------------------------------------------------------*  00186810
*                                                                       00186900
GDS8061L EQU   *-GDS8061            End of Major Vector x'8061'         00187000
*                                                                       00187100
GDS1212L EQU   *-GDS1212            End of GDS Variable x'1212'         00187200
*                                                                       00187300
MDSMUL   EQU   *-MDSMU              End of GDS Variable x'1310'         00187400
*                                                                       00187500
**********************************************************************  00187600
         EJECT                                                          00188000
         PRINT NOGEN                                                    00188100
VTAMACB  ACB   AM=VTAM,APPLID=VTAMAPPL,EXLST=EXITS,MACRF=LOGON          00188200
         EJECT                                                          00188300
RPL1     RPL   AM=VTAM,ACB=VTAMACB,AAREA=RPL1X,AAREALN=L'RPL1X          00188400
RPL1X    ISTRPL6                                                        00188500
         EJECT                                                          00188600
RPL2     RPL   AM=VTAM,ACB=VTAMACB,AAREA=RPL2X,AAREALN=L'RPL2X          00188700
RPL2X    ISTRPL6                                                        00188800
         EJECT                                                          00188900
RPL3     RPL   AM=VTAM,ACB=VTAMACB,AAREA=RPL3X,AAREALN=L'RPL3X          00189000
RPL3X    ISTRPL6                                                        00189100
         EJECT                                                          00189200
RPL4     RPL   AM=VTAM,ACB=VTAMACB,AAREA=RPL4X,AAREALN=L'RPL4X          00189300
RPL4X    ISTRPL6                                                        00189400
         EJECT                                                          00189500
RPL5     RPL   AM=VTAM,ACB=VTAMACB,AAREA=RPL5X,AAREALN=L'RPL5X          00189600
RPL5X    ISTRPL6                                                        00189700
         EJECT                                                          00189800
EXITS    EXLST AM=VTAM,ATTN=ATTN,SCIP=SCIP,LOGON=LOGON                  00189900
         EJECT                                                          00190000
         DS    0H                                                       00190100
RECVREC  DS    XL4                                                      00190200
RECVRECL EQU   *-RECVREC                                                00190300
*                                                                       00190400
         DS    0H                                                       00190500
MESSAGE  DS    CL259                                                    00190600
         EJECT                                                          00190700
ERRMSG1  DC    AL2(ERRMSG1L),AL2(0)                                     00190800
         DC    C'TSO2NETV - NO PARAMETERS SPECIFIED'                    00190900
ERRMSG1L EQU   *-ERRMSG1                                                00191000
*                                                                       00191100
ERRMSG2  DC    AL2(ERRMSG2L),AL2(0)                                     00191200
         DC    C'TSO2NETV - NETVIEW LU NAME NOT SPECIFIED OR INVALID'   00191300
ERRMSG2L EQU   *-ERRMSG2                                                00191400
*                                                                       00191500
ERRMSG3  DC    AL2(ERRMSG3L),AL2(0)                                     00191600
         DC    C'TSO2NETV - COMMAND NOT SPECIFIED'                      00191700
ERRMSG3L EQU   *-ERRMSG3                                                00191800
*                                                                       00191900
ERRMSG4  DC    AL2(ERRMSG4L),AL2(0)                                     00192000
         DC    C'TSO2NETV - VTAM OPEN ACB FAILED'                       00192100
ERRMSG4L EQU   *-ERRMSG4                                                00192200
*                                                                       00192300
ERRMSG5  DC    AL2(ERRMSG5L),AL2(0)                                     00192400
         DC    C'TSO2NETV - APPCCMD CONTROL='                           00192500
CONTROL  DS    CL8                                                      00192600
         DC    C', QUALIFY='                                            00192700
QUALIFY  DS    CL8                                                      00192800
         DC    C' FAILED, R15=X'''                                      00192900
R15VALUE DC    CL8' '                                                   00193000
         DC    C''', R0=X'''                                            00193100
R0VALUE  DC    CL8' '                                                   00193200
         DC    C''', RCPRI=X'''                                         00193300
RCPRI    DC    CL4' '                                                   00193400
         DC    C''', RCSEC=X'''                                         00193500
RCSEC    DC    CL4' '                                                   00193600
         DC    C''''                                                    00193700
ERRMSG5L EQU   *-ERRMSG5                                                00193800
*                                                                       00193900
ERRMSG6  DC    AL2(ERRMSG6L),AL2(0)                                     00194000
         DC    C'TSO2NETV - RECEIVE TIMER EXPIRED.  NO OUTPUT RECEIVED.*00194100
                '                                                       00194200
ERRMSG6L EQU   *-ERRMSG6                                                00194300
*                                                                       00194400
ERRMSG7  DC    AL2(ERRMSG7L),AL2(0)                                     00194500
         DC    C'TSO2NETV - LU 6.2 ERROR OCCURRED.  SNACR RECEIVED WITH*00194600
                SENSE CODE=X'''                                         00194700
ERRSENSE DC    CL8' '                                                   00194800
         DC    C''''                                                    00194900
ERRMSG7L EQU   *-ERRMSG7                                                00195000
*                                                                       00195100
ERRMSG8  DC    AL2(ERRMSG8L),AL2(0)                                     00195200
         DC    C'TSO2NETV - VTAM SETLOGON MACRO FAILED'                 00195300
ERRMSG8L EQU   *-ERRMSG8                                                00195400
*                                                                       00195500
ERRMSG9  DC    AL2(ERRMSG9L),AL2(0)                                     00195600
         DC    C'TSO2NETV - LU 6.2 ERROR, RECEIVE POSTED WITH ''DATA''' 00195700
ERRMSG9L EQU   *-ERRMSG9                                                00195800
*                                                                       00195900
ERRMSG10 DC    AL2(ERRMSG10L),AL2(0)                                    00196000
         DC    C'TSO2NETV - LU 6.2 ERROR, RECEIVE POSTED WITH ''SEND''' 00196100
ERRMSG10L EQU   *-ERRMSG10                                              00196200
*                                                                       00196300
ERRMSG11 DC    AL2(ERRMSG11L),AL2(0)                                    00196400
         DC    C'TSO2NETV - LU 6.2 ERROR, RECEIVE POSTED WITH ''CONFIRM*00196500
               ATION'''                                                 00196600
ERRMSG11L EQU   *-ERRMSG11                                              00196700
*                                                                       00196800
ERRMSG12 DC    AL2(ERRMSG12L),AL2(0)                                    00196900
         DC    C'TSO2NETV - LU 6.2 ERROR, RECEIVE POSTED WITH ''DEALLOC*00197000
               ATE'''                                                   00197100
ERRMSG12L EQU   *-ERRMSG12                                              00197200
*                                                                       00197300
ERRMSG13 DC    AL2(ERRMSG13L),AL2(0)                                    00197400
         DC    C'TSO2NETV - LU 6.2 ERROR, RECEIVE POSTED WITH ''LOG_DAT*00197500
               A'''                                                     00197600
ERRMSG13L EQU   *-ERRMSG13                                              00197700
*                                                                       00197800
ERRMSG14 DC    AL2(ERRMSG14L),AL2(0)                                    00197900
         DC    C'TSO2NETV - UNABLE TO GET STORAGE FOR BUFFER'           00198000
ERRMSG14L EQU   *-ERRMSG14                                              00198100
*                                                                       00198110
ERRMSG15 DC    AL2(ERRMSG15L),AL2(0)                                    00198120
         DC    C'TSO2NETV - UNABLE TO FREE STORAGE FOR BUFFER'          00198130
ERRMSG15L EQU   *-ERRMSG15                                              00198140
*                                                                       00198200
ERRMSG99 DC    AL2(ERRMSG99L),AL2(0)                                    00198300
         DC    C'TSO2NETV - OUTPUT RESPONSE WAS TRUNCATED DUE TO MAXIMU*00198400
               M LENGTH RESTRICTION'                                    00198500
ERRMSG99L EQU   *-ERRMSG99                                              00198600
*                                                                       00198700
         EJECT                                                          00198800
         IKJCPPL                                                        00198900
         IKJPSCB                                                        00199000
         IFGACB AM=VTAM                                                 00199100
         IFGRPL AM=VTAM                                                 00199200
         ISTFM5                                                         00199300
         ISTSLCNS                                                       00199400
         ISTSLD                                                         00199500
         ISTDNIB                                                        00199600
         ISTUSFBC                                                       00199700
MNIBLEN  EQU   *-ISTDNIB                                                00199800
         IFGEXLST AM=VTAM                                               00199900
IFGEXLST DSECT                                                          00200000
MEXTLEN  EQU   *-IFGEXLST+100                                           00200100
         END                                                            00200200
//LKED.SYSLMOD DD DSN=ESPAAA.LINKLIB(TSO2NETV),DISP=SHR                 00200300
//                                                                      00200400
